//---------------------------------------------------------------------------
//pomocn knihovna
//obsahuje funkce potebn pro tvorbu prostorovho modelu ternu a zkladn datov tdy
//napsal Jan Havrlnat jako soust diplomov prce
//--Automatizovan tvorba prostorovch model map--
//v roce 2002
//---------------------------------------------------------------------------

#ifndef VrmlH
#define VrmlH
#include <vector>
#include "geometrie.h"
//---------------------------------------------------------------------------

using namespace std;
//Tida popisujc bod v rovin a jej metody
class Hbod2D
{
  protected:
  int x,y;
  public:
  //metody pro zskn souadnic
  int get_x(){return x;}
  int get_y(){return y;}
  //konstruktory
  Hbod2D(){x=0;y=0;}
  Hbod2D(int sx,int sy){x=sx;y=sy;}
  //metody pro zpis a ten souadnic
  void Zapis(int sx,int sy){x=sx;y=sy;}
  int Cti_x(){return x;}
  void Zapis_x(int i){x=i;}
  void Zapis(Hbod2D bod){x=bod.x;y=bod.y;}
  void Cti(int &sx, int &sy){sx=x;sy=y;}
  //definice opertor pro prci se souadnicemi
  bool operator== (Hbod2D k){ if(x==k.x && y==k.y)return true; return false; }
    operator TPoint () {return TPoint(x,y);}
  operator Tpoint () {return Tpoint(x,y);}
  operator TRect () {return TRect(x,y,x+2,y+2);}
  //metoda pro vpoet smrnku na dan bod
  float Uhel(Hbod2D B){float k=atan2(x-B.get_x(),y-B.get_y());  if(k<0)k=k+M_PI*2 ; return k;  }
  //metody pro vpoet vzdlenosti k danmu bodu
    float Vzdalenost(int kx,int ky)
  {
    if(x==kx && y==ky) return 0;
    return sqrt((x-kx)*(x-kx)+(y-ky)*(y-ky));
  }

  float Vzdalenost(Hbod2D bod)
  {
    if(x==bod.x && y==bod.y) return 0;
    return sqrt((x-bod.x)*(x-bod.x)+(y-bod.y)*(y-bod.y));
  }
  //metoda pro vpoet "rajnu"
  Hbod2D Trans(float delka,float uhel){ return Hbod2D(x+sin(uhel)*delka,y+cos(uhel)*delka);   }

};

//---------------------------------------------------------------------------

//tda pro popis vrstevnice
class Hcara
{
  int vyska;  //vka dan vrstevnice
  bool kolo;  //udv jestli je vrstevnice uzaven
  int pocetbodu;  //poet bod na vrstevnici
  int delka1,delka2; //dlka k dal vrstevnici (pro spojovn vrstevnic)
  float uhel1,uhel2; //smr k dal vrstevnici (pro spojovn vrstevnic)
  int spoj1,spoj2;  //slo konce dal vrstevnice (pro spojovn vrstevnic)
  int xmin,ymin,xmax,ymax ; //minimln a maximlen souadnice na e (pro urychlen zobrazen)

  vector<Hbod2D> body; //kontejner s body
  public:
  //konstruktor
  Hcara(){pocetbodu=0;vyska=-1;kolo=false;xmin=999999;xmax=0;ymin=999999;ymax=0;}
  Hcara(istream &f,int pocet,bool kol,int vy);
  Hcara(istream &f,int pocet,bool kol,int vy,int, int);
  //metoda pro vymazn bod na e
  void clear(){pocetbodu=0;body.clear();}
  //metody pro pidn bod na ru na konec
  void Pridej(int x,int y)
  {
    if(pocetbodu>0)
    {
      if( !(Hbod2D(x,y)==body[pocetbodu-1])) //test identity bodu
      {
        body.push_back(Hbod2D(x,y));//pidn do kontejneru

        if(x<xmin)xmin=x;  //zjitn minimln a maximln souadnice
        if(x>xmax)xmax=x;
        if(y<ymin)ymin=y;
        if(y>ymax)ymax=y;
        pocetbodu++;
      }

    }
    else
    {
      body.push_back(Hbod2D(x,y));
      if(x<xmin)xmin=x;
      if(x>xmax)xmax=x;
      if(y<ymin)ymin=y;
      if(y>ymax)ymax=y;
      pocetbodu++;

    }
  }
  void Pridej(Hbod2D b)
  {
    if(pocetbodu>0)
    {
      if( !(b==body[pocetbodu-1]))
      {
        body.push_back(b);
        int x=b.get_x();
        int y=b.get_y();
        if(x<xmin)xmin=x;
        if(x>xmax)xmax=x;
        if(y<ymin)ymin=y;
        if(y>ymax)ymax=y;
        pocetbodu++;

      }
    }
    else
    {
      body.push_back(b);
      int x=b.get_x();
      int y=b.get_y();
      if(x<xmin)xmin=x;
      if(x>xmax)xmax=x;
      if(y<ymin)ymin=y;
      if(y>ymax)ymax=y;
      pocetbodu++;
    }
  }
  //metody pro zadn parametr ry
  void set_konec1(float uhel,int spoj){uhel1=uhel;spoj1=spoj;}
  void set_konec2(float uhel,int spoj){uhel2=uhel;spoj2=spoj;}
  void set_konecdel1(float delka,int spoj){delka1=delka;spoj1=spoj;}
  void set_konecdel2(float delka,int spoj){delka2=delka;spoj2=spoj;}
  void set_vyska(int v){vyska=v;}
  void set_kolo(){kolo=true;}
  //metody pro zjitn prametr ry
  float get_smer1(){return uhel1;}
  float get_smer2(){return uhel2;}
  float get_delka1(){return delka1;}
  float get_delka2(){return delka2;}
  int get_spoj1(){return spoj1;}
  int get_spoj2(){return spoj2;}
  int get_xmin(){return xmin;}
  int get_xmax(){return xmax;}
  int get_ymin(){return ymin;}
  int get_ymax(){return ymax;}
  int get_pocetbodu(){return pocetbodu;}
  Hbod2D get_bod(int b)
  {
    if(b>=pocetbodu)
    { //ShowMessage("chyba 100");
      return Hbod2D(0,0);
    }
    else  return body[b];
  }
  int get_vyska(){return vyska;}
  //metoda pro smazn danho bodu
  void del_bod(int bod)
  {
    #ifdef _DEBUG
      if(bod>=pocetbodu ) ShowMessage("error 204");
    #endif

    vector<Hbod2D>::iterator i=body.begin();
    body.erase(i+bod);           pocetbodu--;
  }
  //metoda pro smazn bod
  void del_body(int bodp,int bodk)
  {
    #ifdef _DEBUG
      if(bodk>=pocetbodu ||bodp>bodk) ShowMessage("error 2004");
    #endif

    vector<Hbod2D>::iterator i=body.begin();
    body.erase(i+bodp,i+bodk); pocetbodu=pocetbodu-(bodk-bodp+1);
  }
  //metoda pro zmnu souadnic danho bodu
  void Posun_bod(int i,int x,int y){body[i].Zapis(x,y);}
  //metoda pro zjitn transformanch koeficient danch bod
  //pro ortogonln metodu
  void get_koef(double &a1,double &a2,int bodp,int bodk)
  {
    #ifdef _DEBUG
      if(bodp>=pocetbodu|| bodk>=pocetbodu ||bodp<0||bodk<0) ShowMessage("error 207");
      if(0>((body[bodp].get_x()-body[bodk].get_x())*(body[bodp].get_x()-body[bodk].get_x())+(body[bodp].get_y()-body[bodk].get_y())*(body[bodp].get_y()-body[bodk].get_y())))
        ShowMessage("error 208");
      if(0>((body[bodp].get_x()-body[bodk].get_x())*(body[bodp].get_x()-body[bodk].get_x())+(body[bodp].get_y()-body[bodk].get_y())*(body[bodp].get_y()-body[bodk].get_y())))
        ShowMessage("error 209");
  
      if(0>       sqrt((body[bodp].get_x()-body[bodk].get_x())*(body[bodp].get_x()-body[bodk].get_x())+(body[bodp].get_y()-body[bodk].get_y())*(body[bodp].get_y()-body[bodk].get_y())))
        ShowMessage("error 210");
      if(0> sqrt((body[bodp].get_x()-body[bodk].get_x())*(body[bodp].get_x()-body[bodk].get_x())+(body[bodp].get_y()-body[bodk].get_y())*(body[bodp].get_y()-body[bodk].get_y())))
        ShowMessage("error 211");
  
  
    #endif
    a1=(body[bodk].get_x()-body[bodp].get_x())/sqrt((body[bodp].get_x()-body[bodk].get_x())*(body[bodp].get_x()-body[bodk].get_x())+(body[bodp].get_y()-body[bodk].get_y())*(body[bodp].get_y()-body[bodk].get_y()));
    a2=(body[bodk].get_y()-body[bodp].get_y())/sqrt((body[bodp].get_x()-body[bodk].get_x())*(body[bodp].get_x()-body[bodk].get_x())+(body[bodp].get_y()-body[bodk].get_y())*(body[bodp].get_y()-body[bodk].get_y()));

  }
  //zjitn ortogonln kolmice danho bodu bod1
  //a1,a2 transforman koeficienty
  //bodp potek soadnicov soustavy

  float get_odchylka(double a1,double a2,int bodp,int bod1)
  {
    return  a2*(body[bod1].get_x()-body[bodp].get_x())-a1*(body[bod1].get_y()-body[bodp].get_y());
  }
  //metoda pro uloen ry do souboru
  void  Zapis(ofstream &car);
};

//---------------------------------------------------------------------------
//tda pro popis bodu v prostoru
class Hbod3D : public Hbod2D
{
  int z; //souadnice
  public:
  TPoint getPoint(){return TPoint(x,y);} //zjitn souadnic
  //metoda pro vloen bodu
  void Pridej(Hbod2D a,int  v){x=a.get_x();y=a.get_y();z=v;    }
  //definice opertor
  bool operator== (Hbod3D k){ if(x==k.x && y==k.y)return true; return false; }
    bool operator== (Hbod2D k){ if(x==k.get_x() && y==k.get_y())return true; return false; }
   //metoda pro zjitn vzdlenosti mezi dvma body
    float Vzdalenost(Hbod3D k)
  {
    return sqrt((x-k.x)*(x-k.x)+(y-k.y)*(y-k.y));
  }
  float Vzdalenost(int kx,int ky){return sqrt((x-kx)*(x-kx)+(y-ky)*(y-ky));}
  //definice opertoru petypovn
  operator TPoint () {return TPoint(x,y);}
  //metody pro zjitn souadnic bodu
  int get_x(){return x;}
  int get_y(){return y;}
  int get_z(){return z;}
  //konstruktory
  Hbod3D(int _x,int _y,int _z){x=_x;y=_y;z=_z;}
  Hbod3D(){x=0;y=0;z=0;}
} ;

//---------------------------------------------------------------------------
//tda pro popis mapy sloen z vrstevnic(ar) a samostatnch prostorovch bod
class Hmapa
{
  vector<Hcara>cary; //kontejner na vrstevnice
  vector<Hbod3D>body3D; //kontejner na samostatn body
  unsigned int pocetcar; //poet vrstevnic v map
  unsigned int pocetbodu3D; //poet samostatnch bod v map
  public:
  //definice opertoru piazen
  Hmapa& operator= ( Hmapa& m){ vyska=m.vyska;sirka=m.sirka;return *this;}

  int vyska,sirka; //rozmry mapy
  //konsturktor
  Hmapa(){pocetcar=0;pocetbodu3D=0;  cary.clear();body3D.clear();}
  //metoda pro pidnry do mapy
  void Novacara(){cary.push_back(Hcara());pocetcar++;}
  //metoda pro pidn bodu na poslen ru v kontejneru
  void Pridej_bod_na_posledni_caru(int x,int y){cary[get_pocetcar()-1].Pridej(x,y);}
  void Pridej_bod_na_posledni_caru(Hbod2D b){cary[get_pocetcar()-1].Pridej(b);}
  //metoda pro nastaven parametr vrstevnice posledn v konejneru
  void set_konec1_na_posledni_caru(float uhel,int spoj){cary[get_pocetcar()-1].set_konec1(uhel,spoj);}
  void set_konec2_na_posledni_caru(float uhel,int spoj){cary[get_pocetcar()-1].set_konec2(uhel,spoj);}
  void set_konecdel_na_caru(int cara,float del,int spoj,bool kon)
  {
    if(kon)cary[cara].set_konecdel1(del,spoj);
    else cary[cara].set_konecdel2(del,spoj);
  }
  //metoda pro smazn ry
  void Del_cara(i)
  {
    pocetcar--;
    swap(cary[i],cary[pocetcar]);
  }
//nepouit funkce
//  void konce_vzdalenost_test1(int ,int ,bool& ,int&,float&,float&);
//  void konce_vzdalenost_test2(int ,int ,bool& ,int&,float&,float&);

//  int get_spoj_na_care(int i,bool zac){if(zac) return cary[i].get_spoj1();return cary[i].get_spoj2();}
//  float get_delka_na_care(int i,bool zac){ if(zac) return cary[i].get_delka1();return cary[i].get_delka2();}
 //metoda pro zjitn potu ar v map
    int get_pocetcar(){ return pocetcar;}      //if(&cary==NULL)return 0;   return cary.size();}
 //metoda pro zjitn potu bod na konkrtn e
  int get_pocetbodu_nacare(int cara)
  {
    if(cara>= get_pocetcar())
    {ShowMessage("chyba 201");}
    return cary[cara].get_pocetbodu();
  }
  //metoda vrac dano ru m
  Hcara get_cara(int m){return cary[m];}
  //metoda pro zjitn souadnic bodu mis na e car
  Hbod2D get_bod(int car,int mis){return cary[car].get_bod(mis);  }
  //pomocn metoda pro zobrazen jednotlivch bod na map
  //pomoc vybarven vypotenho tverce
  TRect get_bod_f(int car,int mis,int px,int py,double zvec)
  {
    int x=(cary[car].get_bod(mis).get_x()-px)*zvec;
    int y=(cary[car].get_bod(mis).get_y()-py)*zvec;
    return TRect(x,y,x+2,y+2);
  }
  //metody pro zjitn a nastaven vky souadnice
  int get_vyska(int car){return cary[car].get_vyska();}
  void set_vyska(int car,int vyska){cary[car].set_vyska(vyska);}
  //metody pro zjitn souadnic kam se m vypsat nadmosk vka na map
  int Get_vyska_x(int car){ return cary[car].get_bod(get_pocetbodu_nacare(car)/2).get_x();   }
  int Get_vyska_y(int car){ return cary[car].get_bod(get_pocetbodu_nacare(car)/2).get_y();   }
  //metoda pro zmnu souadnic bodu bod na e car na souadnice x,z
  void Presun_bod2D(int car,int bod,int x,int y)
  {
    if(x>sirka) x=sirka;
    if(y>vyska) y=vyska;
    cary[car].Posun_bod(bod,x,y);
  }
  //metoda pro zjitn poslenho bodu na poslen e v kontejneru
  Hbod2D get_posledi_bod2D(){ return  cary[pocetcar-1].get_bod(cary[pocetcar-1].get_pocetbodu()-1);}
  //metoda pro nastaven pznaku vrstevnice, e je uzaven
  void set_kolo(int car){cary[car].set_kolo();}
  //metoda mae bod na dan e
  void del_bod2D(int car,int bod)
  {
    #ifdef _DEBUG
      if(car>=pocetcar ) ShowMessage("error 203");
    #endif
    cary[car].del_bod(bod);
  }
  //matoda pro smazn bod na e
  void del_body2D(int car,int bodp,int bodk)
  {
    /*  #ifdef _DEBUG
            if(car>=pocetcar ) ShowMessage("error 203");
           #endif */
    cary[car].del_body(bodp,bodk);
  }
  /*  nepouit funkce
  void spojit_car(int i,int j,bool i1,bool j1){
        if(i1 && j1){
         for
        }


      }   */
  /*   nepouit funkce
  bool bod_na_obr(int car,int bod,int sir,int vys,int posx,int posy ,double zvec)
  {
    if(bod>=cary[car].get_pocetbodu())ShowMessage("chba 111");
    if((cary[car].get_bod(bod).get_x()-posx)*zvec<0 || (cary[car].get_bod(bod).get_x()-posx)*zvec>sir ||
       (cary[car].get_bod(bod).get_y()-posy)*zvec<0 || (cary[car].get_bod(bod).get_y()-posy)*zvec>vys) return false;
    return true;
  }      */
  //metoda pro pekreslen mapy na obrazovce
  //zjitn zda se m ra zobrazit na obazovce
  bool cara_na_obr(int car,int sir,int vys,int posx,int posy ,double zvec)
  {
    if((cary[car].get_xmax()-posx)*zvec<0 || (cary[car].get_xmin()-posx)*zvec>sir ||
       (cary[car].get_ymax()-posy)*zvec<0 || (cary[car].get_ymin()-posy)*zvec>vys) return false;
    return true;

  }
  /*   nepouit funkce
  bool bod_u_cary(int car,TPoint a)
  {
    if( a.x<=cary[car].get_xmax() && a.x>=cary[car].get_xmin() &&
        a.y<=cary[car].get_ymax() && a.y>=cary[car].get_ymin()) return true;
    else return false;

  }  */
  // definice opertoru indexovn
  Hbod3D operator[] (int k){return body3D[k];}
  //metoda pro vloen samostatnho bodu
  void  Vloz_bod3D(int x,int y,int z){      body3D.push_back(Hbod3D(x,y,z));           pocetbodu3D++;}
  //metoda pro zskn soadnic samostatnho bodu
  void  Get_bod3D(int c,int& x,int& y,int& z){x=body3D[c].get_x();y=body3D[c].get_y();z=body3D[c].get_z();}
  //metoda pro vymazn kontejneru se samostatnmi body
  void  Clear3D(void){body3D.clear();}
  //metoda pro zjitn potu samostatnch bod
  int Get_pocet3D(void){return pocetbodu3D;}
  //metoda pro smazn samostatnho bodu
  void Zrus_bod3D(int l){body3D.erase(body3D.begin()+l) ; }
  //metoda pro zjitn vzdlenosti bodu od bodu o zadanch souadnicch
  float Vzdalenost3D(int i,int _x,int _y){return body3D[i].Vzdalenost(_x,_y);}
  void Del_bod3D(int bod)
  {
    pocetbodu3D--;
    swap(body3D[bod],body3D[pocetbodu3D]);
  }
  //metoda pro zjitn transformanch koeficinet pro ortogonln metodu
  void get_koef(double &a1,double &a2,unsigned int car,int bodp,int bodk)
  {
    #ifdef _DEBUG
      if(car>=pocetcar ) ShowMessage("error 205");
    #endif
    cary[car].get_koef(a1,a2,bodp,bodk);
  }
  //metoda pro vpoet ortogonln komice bodu bod1
  float get_odchlka(double a1,double a2,unsigned int car,int bodp,int bod1)
  {
    #ifdef _DEBUG
      if(car>=pocetcar ) ShowMessage("error 206");
    #endif
    return cary[car].get_odchylka(a1,a2,bodp,bod1);

  }
  //metoda pro vloen nov ry na mapu
  void  Vloz_caru(Hcara *ncara)
  {
    vector<Hcara>::iterator i=cary.begin();
    cary.insert(i+pocetcar,*ncara);
    pocetcar++;
  }
  //metody pro naten ar ze souboru
  void Precti(ifstream &car);
  void Precti(ifstream &car,int plusx,int plusy);
  //metoda pro uloen ar do souboru
  void Zapis_car(ofstream &car);
  // metoda pro uloen ar do jin mapy
  void Zapis_car(Hmapa* m);
  //mtody pro naten samostatnch bod ze souboru
  void Precti_Bod3D(ifstream &bod);
  void Precti_Bod3D(ifstream &bod,int,int);
  //metoda pro uloen bod do souboru
  void Zapis_bod3D(ofstream &bod);
  //metoda pro zjitn potu vech bod v map
  int Pocet_vsech_bodu();


};


/*
void Hmapa::konce_vzdalenost_test1(int cara1,int cara2,bool& zac2,int& cara,float& del,float& smer)
{
  float del1,del2;
  Hbod2D A,B;
  float s;
  del1=cary[cara1].get_bod(0).Vzdalenost(cary[cara2].get_bod(0));
  A= cary[cara1].get_bod(0).Trans(del1/2,cary[cara1].get_smer1());
  B= cary[cara2].get_bod(0).Trans(del1/2,cary[cara2].get_smer1());
  del2 = A.Vzdalenost(B);

  if(del1>=del2)
  {
    del1=del1+del2;
    s= (fabs(fabs(cary[cara1].get_smer1()-cary[cara2].get_smer1() )-M_PI)*200/M_PI); //  s= (fabs(fabs( konec.konec[i].smer-konec.konec[j].smer)-M_PI)*200/M_PI);
    if(del1<del)
    {
      //   zac1=true;
      zac2=true;
      del=del1;
      cara=cara2;
      smer=s;
    }
  }


  del1=cary[cara1].get_bod(0).Vzdalenost(cary[cara2].get_bod(cary[cara2].get_pocetbodu()-1));
  A= cary[cara1].get_bod(0).Trans(del1/2,cary[cara1].get_smer1());
  B= cary[cara2].get_bod(cary[cara2].get_pocetbodu()-1).Trans(del1/2,cary[cara2].get_smer2());
  del2 = A.Vzdalenost(B);

  if(del1>=del2)
  {
    del1=del1+del2;
    s= (fabs(fabs(cary[cara1].get_smer1()-cary[cara2].get_smer2() )-M_PI)*200/M_PI); //  s= (fabs(fabs( konec.konec[i].smer-konec.konec[j].smer)-M_PI)*200/M_PI);
    if(del1<del)
    {
      // zac1=true;
      zac2=false;
      del=del1;
      cara=cara2;
      smer=s;
    }
  }
}
void Hmapa::konce_vzdalenost_test2(int cara1,int cara2,bool& zac2,int& cara,float& del,float& smer)
{
  float del1,del2;
  Hbod2D A,B;
  float s;
  del1=cary[cara1].get_bod(cary[cara1].get_pocetbodu()-1).Vzdalenost(cary[cara2].get_bod(0));
  A= cary[cara1].get_bod(cary[cara1].get_pocetbodu()-1).Trans(del1/2,cary[cara1].get_smer2());
  B= cary[cara2].get_bod(0).Trans(del1/2,cary[cara2].get_smer1());
  del2 = A.Vzdalenost(B);

  if(del1>=del2)
  {
    del1=del1+del2;
    s= (fabs(fabs(cary[cara1].get_smer2()-cary[cara2].get_smer1() )-M_PI)*200/M_PI); //  s= (fabs(fabs( konec.konec[i].smer-konec.konec[j].smer)-M_PI)*200/M_PI);
    if(del1<del)
    {
      //  zac1=false;
      zac2=true;
      del=del1;
      cara=cara2;
      smer=s;
    }
  }
  del1=cary[cara1].get_bod(cary[cara1].get_pocetbodu()-1).Vzdalenost(cary[cara2].get_bod(cary[cara2].get_pocetbodu()-1));
  A= cary[cara1].get_bod(cary[cara1].get_pocetbodu()-1).Trans(del1/2,cary[cara1].get_smer2());
  B= cary[cara2].get_bod(cary[cara2].get_pocetbodu()-1).Trans(del1/2,cary[cara2].get_smer2());
  del2 = A.Vzdalenost(B);

  if(del1>=del2)
  {
    del1=del1+del2;
    s= (fabs(fabs(cary[cara1].get_smer2()-cary[cara2].get_smer2() )-M_PI)*200/M_PI); //  s= (fabs(fabs( konec.konec[i].smer-konec.konec[j].smer)-M_PI)*200/M_PI);
    if(del1<del)
    {
      // zac1=false;
      zac2=false;
      del=del1;
      cara=cara2;
      smer=s;
    }
  }


} */
//---------------------------------------------------------------------------
/*
struct Hvrml
{

  int x,y;
  int vyska,sirka;
  //char* filename;
  String filename;
  float MinMaxP;

}   ;   */
//---------------------------------------------------------------------------

//stuktura pro uloen parametr vcensobn reprezentace modelu
//v programu generator
struct Hlod
{
  int x,y,delka;
  float rozliseni;

  Hlod(){}
  Hlod(int _x,int _y,int _delka,float roz){x=_x;y=_y;delka=_delka;rozliseni=roz;}


};
//---------------------------------------------------------------------------
// tda pro uloen spojnic trojhelnkov st a jejich parametr

class dvoj
{
  int tr1,tr2;
  int c1,c2;
  public:
  dvoj(){tr1=-1;tr2=-1;}
  void Pridej(int a,int b,int c){c1=a;c2=b;tr1=c;}
  void Dodej(int a){tr2=a;}
  bool Stejne(int a,int b) ;
                   /*
              {
                  if(c1==a || c2==a){if(c1==b || c2==b) return true;}
                      return false;

              }    */
  int get_tr1(){return tr1;}
  int get_c1(){return c1;}
  int get_c2(){return c2;}
};
//===================================================================
//tda pro uloen seznamu spojen s konkrtnm bodem v trojhelnkov sti
class katalog_dvoj
{
  public:
  vector<int>dv;
  vector<int>spoj;
  void Pridej(int i,int sp){dv.push_back(i); spoj.push_back(sp); }
  int get_pocet(){return dv.size();}

}
;


//===================================================================
//tda definujc jednotliv trojhelnch v troj. sti

class troj
{
  int c1,c2,c3;
  int troj[3];
  public:
  troj(){troj[0]=-1;troj[1]=-1;troj[2]=-1;}
  int get_c1(void){return c1;}
  int get_c2(void){return c2;}
  int get_c3(void){return c3;}
  void Pridej(int a,int b,int c){c1=a;c2=b;c3=c;}
  void Pridej(int a,int b,int c,int d){c1=a;c2=b;c3=c;troj[0]=d;}
  void get_tr(Hbod2D *bodin,Hbod2D *bodout)
  {
    bodout[0]=bodin[c1];
    bodout[1]=bodin[c2];
    bodout[2]=bodin[c3];
  }
  void Dodej(int a1,int a2,int tr) ;
  int get_troj(int i){return troj[i];}
  void get_c(int t,int& a1,int& a2,int& a3);
  String Tisk();
  void GetT(Hbod3D* cb,int& x,int& y)
  {
    x=(cb[c1].get_x()+cb[c2].get_x()+cb[c3].get_x())/3;
    y=(cb[c1].get_y()+cb[c2].get_y()+cb[c3].get_y())/3;
  }
};
//===================================================================
//tda pro popis segmentu vrstevnice
//urichluje tvorbu vkov st
class Husecka
{
  public:
  int bod1x,bod1y,bod2x,bod2y;
  Husecka(){bod1x=-1;bod2x=-1;}
  void set(int ax,int ay,int bx,int by){bod1x=ax;bod1y=ay;bod2x=bx;bod2y=by;}
  void set(Hbod2D a,Hbod3D b){bod1x=a.get_x();bod1y=a.get_y();bod2x=b.get_x();bod2y=b.get_y();      }
};
//---------------------------------------------------------------------------
//tda pro popis segmentu vrstevnice
//urichluje tvorbu vkov st

class Husecka3D : public Husecka
{
  public:
  int vyska;
  void set(Hbod2D a,Hbod2D b,int v){vyska=v; bod1x=a.get_x(); bod1y=a.get_y(); bod2x=b.get_x(); bod2y=b.get_y();}
};
//---------------------------------------------------------------------------
//tda pro uloen trojhelnkov st a jejech bod

class mapa_troj
{
  public:
  troj* triangl;
  int poctroj;
  void get_tr(int i,Hbod2D *t)
  {
    triangl[i].get_tr(bod,t);
  }
  Hbod3D* bod;
  int pocbod;
  ~mapa_troj(){delete[] bod;delete[] triangl;}
  void Alloc(int tr,int bo){triangl=new troj[tr];poctroj=tr;pocbod=bo;bod=new Hbod3D[bo] ;}
  void Alloctr(int tr){triangl=new troj[tr]; poctroj=tr;}
  void Allocbo (int bo){pocbod=bo;bod=new Hbod3D[bo] ;}

} ;

//---------------------------------------------------------------------------

//deklarace funkce
void Vyskova_mapa(Hmapa* ,float** ,int ,int,void(*P)());
#endif