//---------------------------------------------------------------------------
//pomocn knihovna
//obsahuje funkce potebn pro tvorbu prostorovho modelu ternu
//napsal Jan Havrlnat jako soust diplomov prce
//--Automatizovan tvorba prostorovch model map--
//v roce 2002
//---------------------------------------------------------------------------

#include  "geometrie.h"
#pragma package(smart_init)

//===================================================================
//funkce pevzata  z adresy http://www.geometryalgorithms.com  a upravena
// dist_Point_to_Segment(): get the distance of a point to a segment.
//    Input:  a Point P and a Segment S (in any dimension)
//    Return: the shortest distance from P to S
float dist_Point_to_Segment( Tpoint P, Tpoint SP0,Tpoint SP1)
{
  TVector v = SP1 - SP0;
  TVector w = P - SP0;

  double c1 = dot(w,v);
  if ( c1 <= 0 )
    return d(P, SP0);

  double c2 = dot(v,v);
  if ( c2 <= c1 )
    return d(P, SP1);

  double b = c1 / c2;
  Tpoint Pb = SP0 + b * v;
  return d(P, Pb);
}
//===================================================================
//funkce pevzata  z adresy http://www.geometryalgorithms.com  a upravena
// Point_to_Segment(): get the point no segment near to point.
//    Input:  a Point P and a Segment S (in any dimension)
//    Return: the point
Tpoint Point_to_Segment( Tpoint P, Tpoint SP0,Tpoint SP1)
{
  TVector v = SP1 - SP0;
  TVector w = P - SP0;

  double c1 = dot(w,v);
  if ( c1 <= 0 )
    return  SP0;

  double c2 = dot(v,v);
  if ( c2 <= c1 )
    return SP1;

  double b = c1 / c2;
  Tpoint Pb = SP0 + b * v;
  return Pb;
}
//===================================================================
//funkce pevzata  z adresy http://www.geometryalgorithms.com  a upravena
// xyorder(): determines the xy lexicographical order of two points
//      returns: (+1) if p1 > p2; (-1) if p1 < p2; and 0 if equal
int xyorder( TPoint* p1, TPoint* p2 )
{
  // test the x-coord first
  if (p1->x > p2->x) return 1;
  if (p1->x < p2->x) return (-1);
  // and test the y-coord second
  if (p1->y > p2->y) return 1;
  if (p1->y < p2->y) return (-1);
  // when you exclude all other possibilities, what remains is...
  return 0;  // they are the same point
}
isLeft( TPoint P0, TPoint P1, TPoint P2 )
{
  return (P1.x - P0.x)*(P2.y - P0.y) - (P2.x - P0.x)*(P1.y - P0.y);
}
//===================================================================
//funkce pevzata  z adresy http://www.geometryalgorithms.com  a upravena
// test intersect of 2 segments and return: 0=none, 1=intersect
int intersect( TPoint A,TPoint B,TPoint C,TPoint D)
{
  if(max(A.x,B.x)<min(C.x,D.x)|| min(A.x,B.x)>max(C.x,D.x) ||
     max(A.y,B.y)<min(C.y,D.y)|| min(A.y,B.y)>max(C.y,D.y))
  return false;
  if(A.x==C.x && A.y==C.y)return -2;
  if(A.x==D.x && A.y==D.y)return -2;
  if(B.x==C.x && B.y==C.y)return -2;
  if(B.x==D.x && B.y==D.y)return -2;
  TPoint temp;
  int k=xyorder( &A, &B);
  if (k > 0)
  { // determine which is leftmost
    temp=A;
    A=B;
    B=temp;
  }
  else if(k==0)return -5 ;
  k=xyorder( &C, &D);
  if (k > 0)
  { // determine which is leftmost
    temp=C;
    C=D;
    D=temp;
  }
  else if(k==0)return -5 ;
  // test for existence of an intersect point
  float lsign, rsign;
  lsign = isLeft(A,B,C);    // s2 left point sign
  rsign = isLeft(A,B,D);    // s2 right point sign
  if (lsign * rsign > 0) // s2 endpoints have same sign relative to s1
    return FALSE;      // => on same side => no intersect is possible
  lsign = isLeft(C,D,A);    // s1 left point sign
  rsign = isLeft(C,D,B);    // s1 right point sign
  if (lsign * rsign > 0) // s1 endpoints have same sign relative to s2
    return FALSE;      // => on same side => no intersect is possible
  // the segments s1 and s2 straddle each other
  return 1;           // => an intersect exists
}
//===================================================================
//Funkce zjist minimln a maximln vku v poli a vrt jejich prmr
//vys pole vek
//odslp, doslp, odrad, dorad meze pole v kterm se m prmr potat
float GetMinMaxPrum(float** vys,int odslp,int doslp,int odrad,int dorad)
{
  float min=999999,max=-9999;
  for(int i=odrad;i<dorad;i++)
  {
    for(int j=odslp;j<doslp;j++)
    {
      if(vys[j][i]<min)min=vys[j][i];
      if(vys[j][i]>max)max=vys[j][i];
    }
  }
  return (max-min)/2+min;
}
