//---------------------------------------------------------------------------
//pomocn knihovna
//obsahuje funkce potebn pro tvorbu prostorovho modelu ternu a zkladn datov tdy
//napsal Jan Havrlnat jako soust diplomov prce
//--Automatizovan tvorba prostorovch model map--
//v roce 2002
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
#ifndef VrmlC
#define VrmlC
#include <vcl.h>
#pragma hdrstop
#include "Vrml.h"
#include <fstream.h>
//#include "Vrmlform.cpp"
//#include "geometrie.cpp"
//---------------------------------------------------------------------------
#pragma package(smart_init)
//funkce pro zjitn minima z t hodnot
int MIN (int i1,int i2,int i3)
{
  return min(min(i1,i2),i3);
}
//funkce pro zjitn maxima ze t hodnot
int MAX (int i1,int i2,int i3)
{
  return max(max(i1,i2),i3);
}
//definice opertoru pro vstup bodu do souboru
ostream& operator << (ostream& vl , Hbod2D bod)
{
  return vl<<bod.get_x()<<"\t"<<bod.get_y();
}
//konstruktor pro naten ry ze souboru
Hcara::Hcara(istream &f,int pocet,bool kol,int vy)
{
  int _x,_y;
  xmin=999999;
  xmax=0;
  ymin=999999;
  ymax=0;
  vyska=vy;
  kolo=kol;
  pocetbodu=0;
  for(int i=0;i<pocet;i++)
  {
    f>>_x>>_y;
    if(_x<xmin)xmin=_x;
    if(_x>xmax)xmax=_x;
    if(_y<ymin)ymin=_y;
    if(_y>ymax)ymax=_y;
    body.push_back(Hbod2D(_x,_y));
    pocetbodu++;
  }
}
//konstruktor pro naten ry ze souboru a zrove posunut
//ry o plusx a plusy
Hcara::Hcara(istream &f,int pocet,bool kol,int vy,int plusx,int plusy)
{
  int _x,_y;
  xmin=999999;
  xmax=0;
  ymin=999999;
  ymax=0;
  vyska=vy;
  kolo=kol;
  pocetbodu=0;
  for(int i=0;i<pocet;i++)
  {
    f>>_x>>_y;
    _x=_x+plusx;
    _y=_y+plusy;
    if(_x<xmin)xmin=_x;
    if(_x>xmax)xmax=_x;
    if(_y<ymin)ymin=_y;
    if(_y>ymax)ymax=_y;
    body.push_back(Hbod2D(_x,_y));
    pocetbodu++;
  }
}
//metoda pro zpis ry do souboru
void  Hcara::Zapis(ofstream &car)
{
  car<<"\t"<<pocetbodu<<"\t"<<kolo<<"\t"<<vyska<<endl;
  for(int j=0;j<pocetbodu;j++)
  {
    car<<body[j]   <<"\t";
  }
}
//metoda pro naten ar  ze souboru
void Hmapa::Precti(ifstream &car)
{
  car>>vyska>>sirka;
  int i,pocet_sou,vy;//,i1=-1;
  int kol;
  while(!car.eof())
  {
    car>>i>>pocet_sou>>kol>>vy;

    if (car.eof()) break;
    pocetcar++;
    cary.push_back(Hcara(car,pocet_sou,kol,vy));
  }
}
//metoda pro naten ar ze souboru a zrove posunut
//mapy o plusx a plusy
void Hmapa::Precti(ifstream &car,int plusx,int plusy)
{
  int v,s;
  car>>v>>s;
  if(plusy+v>vyska) vyska=plusy+v;
  if(plusx+s>sirka) sirka=plusx+s;

  int i,pocet_sou,vy;//,i1=-1;
  int kol;
  while(!car.eof())
  {
    car>>i>>pocet_sou>>kol>>vy;
    if (car.eof()) break;
    pocetcar++;
    cary.push_back(Hcara(car,pocet_sou,kol,vy,plusx,plusy));
  }
}
//metoda pro zpis ar do souboru
void Hmapa::Zapis_car(ofstream &car)
{
  car<<vyska<<"\t"<<sirka<<endl;
  for(int i=0;i<get_pocetcar();i++)
  {
    car<<i;
    cary[i].Zapis(car);
    car<<endl;
  }
}
//metoda pro naten samostatnch bod ze souboru
void Hmapa::Precti_Bod3D(ifstream &bod)
{
  int cb,x,y,z;
  // body3D.Clear();
  bod>>cb>>x>>y>>z;
  while(!bod.eof() && !bod.bad())
  {
    body3D.push_back(Hbod3D(x,y,z));
    pocetbodu3D++;
    bod>>cb>>x>>y>>z;
  }
}
//metoda pro naten samostatnch bod ze souboru a zrove posunut
//o plusx a plusy
void Hmapa::Precti_Bod3D(ifstream &bod,int kx,int ky)
{
  int cb,x,y,z;
  // body3D.Clear();
  bod>>cb>>x>>y>>z;
  while(!bod.eof() && !bod.bad())
  {
    body3D.push_back(Hbod3D(x,y,z));
    pocetbodu3D++;
    x=x+kx;
    y=y+ky;
    bod>>cb>>x>>y>>z;
  }
}
//metoda pro zpis samostatnch bod do souboru
void Hmapa::Zapis_bod3D(ofstream &bod)
{
  int x,y,z;
  for(unsigned int i=0;i<pocetbodu3D;i++)
  {
    Get_bod3D(i,x,y,z);
    if(x>=0)        bod<<i<<"\t"<<x<<"\t"<<y<<"\t"<<z<<endl;
  }
}
 // metoda pro uloen ar do jin mapy
void Hmapa::Zapis_car(Hmapa* m)
{
  pocetcar=m->pocetcar;
  cary.clear();
  for(int i=0;i<m->get_pocetcar();i++)
  {
    cary.push_back(Hcara(m->cary[i]));
  }
}
//metoda pro zjitn zda dan spojnice spojuje stejn body
bool dvoj::Stejne(int a,int b)
{
  if(c1==a || c2==a){if(c1==b || c2==b) return true;}
    return false;
}
//metoda pro pidn sla sousednho trojhenka
void troj::Dodej(int a1,int a2,int tr)
{
  if((a1==c1 && a2==c2) || (a1==c2 && a2==c1))
  {
    troj[0]=tr;
    return;
  }
  if((a1==c2 && a2==c3) || (a1==c3 && a2==c2))
  {
    troj[1]=tr;
    return;
  }
  if((a1==c1 && a2==c3) || (a1==c3 && a2==c1))
  {
    troj[2]=tr;
    return;
  }
}
//metoda pro zjitn sel bod danho trojhelnka
void troj::get_c(int t,int& a1,int& a2,int& a3)
{
  if(t==0)
  {
    a1=c1;
    a2=c2;
    a3=c3 ;
    return;
  }
  if(t==1)
  {
    a1=c2;
    a2=c3;
    a3=c1 ;
    return;
  }
  if(t==2)
  {
    a1=c3;
    a2=c1;
    a3=c2 ;
    return;
  }
}
//pomocn metoda pro vpis struktury troj. st do souboru
String troj::Tisk()
{
  return (String)c1+(String)" "+(String)c2+(String)" "+(String)c3+(String)" "+
  (String)" "+(String)troj[0]+(String)" "+(String)troj[1]+(String)" "+(String)troj[2];
}
//------------------------------------------------------------------------------
//funkce pro zskn mnoiny vek nad pravohlou st
//mapa - tda s definic vouadnic a samostatnch bod pro kterou se generuje vkov s
//vys - dvoroznrn pole do kterho se ukldan zskan vky
//rac, slp - dimenze pole vys
//(*P) - ukazatel na funkci, kter se vol v prbhu funkce pro informaci hlavnho programu o rychlosti prbhu
//ekv - ekvidistance vrstevnic v modelu
void Vyskova_mapa(Hmapa *mapa,float** vys,int slp,int rad, void(*P)(),int ekv)
{
  const int pp=4;
  //rozte bod st
  const float xscale=mapa->sirka/(slp-1.0);
  const float yscale=mapa->vyska/(rad-1.0);
  //pomocn promnn
  int bodcislo[pp];
  double vv1[pp],s1[pp];
  double del;
  bool b=false;
  int pocusec=0;//pocet usecek reprezentujici vrstevnice
  int vmin=99999,vmax (-9999);
  //potn bod v modelu
  for(int i=0;i<mapa->get_pocetcar();i++)
  {
    if(mapa->get_pocetbodu_nacare(i)<2 || mapa->get_vyska(i)==-1)continue;
    pocusec=pocusec-1+mapa->get_pocetbodu_nacare(i);
  }

  if(mapa->Get_pocet3D()<4 && pocusec<2){ShowMessage("nedostatek Bod");return ;}
    
  //alokace prostoru
  Hbod3D* cb = new Hbod3D[mapa->Get_pocet3D()];
  Husecka3D* useck = new Husecka3D[pocusec];

  int  poccb=0;
  pocusec = 0;
  //natn vrstevnic
  for(int i=0;i<mapa->get_pocetcar();i++)
  {
    if(mapa->get_pocetbodu_nacare(i)<2 || mapa->get_vyska(i)==-1)continue;
    if(vmin>mapa->get_vyska(i)) vmin=mapa->get_vyska(i);
    if(vmax<mapa->get_vyska(i)) vmax=mapa->get_vyska(i);
    for(int j=0;j<mapa->get_pocetbodu_nacare(i);j++)
    {
      //  if(mapa->vyska<cb[poccb].get_y())ShowMessage("chyba 10");
      //  if(mapa->sirka<cb[poccb].get_x())ShowMessage("chyba 11");
      if(j!=0 )
      {
        useck[pocusec].set(mapa->get_bod(i,j-1),mapa->get_bod(i,j),mapa->get_vyska(i));
        pocusec++;
      }
    }
  }
  //naten samostatnch bod
  for(int i=0;i<mapa->Get_pocet3D();i++)
  {
    cb[poccb]=(*mapa)[i];
    if(vmin>(*mapa)[i].get_z()) vmin=(*mapa)[i].get_z();
    if(vmax<(*mapa)[i].get_z()) vmax=(*mapa)[i].get_z();
    if(mapa->vyska<cb[poccb].get_y())ShowMessage("chyba 13");
    if(mapa->sirka<cb[poccb].get_x())ShowMessage("chyba 14");
    for(int k=0;k<poccb;k++)
    {
      if(cb[poccb]==cb[k])
      {
        poccb--;
        break;
      }
    }
    poccb++;
  }
  //vpoet potu tverc pro rozdlen mapy na men sti
  int pocet_ctvercu=pocusec/50+poccb/50;
  double tmpp= sqrt(mapa->vyska*pocet_ctvercu/mapa->sirka);
  int cv_radku=(tmpp-(int)tmpp)>0.5?ceil(tmpp):floor(tmpp);
  if(cv_radku<3) cv_radku=3;
  tmpp= sqrt(mapa->sirka*pocet_ctvercu/mapa->vyska);
  int cv_sloupcu=(tmpp-(int)tmpp)>0.5?ceil(tmpp):floor(tmpp);
  if( cv_sloupcu<3)  cv_sloupcu=3;

  //alokace promnn pro poet bod ve tvercch
  int** pocbun = new int* [cv_sloupcu];
  for(int i=0;i<cv_sloupcu;i++)
  {
    pocbun[i]= new int [cv_radku];
    for(int j=0;j<cv_radku;j++)
      pocbun[i][j]=0;
  }
  //alokace promnn pro poet usecek ve tvercch
  int** pocusecek = new int* [cv_sloupcu];
  for(int i=0;i<cv_sloupcu;i++)
  {
    pocusecek[i]= new int [cv_radku];
    for(int j=0;j<cv_radku;j++)
      pocusecek[i][j]=0;
  }
  //zjitn pot bod v jednotlivch tercch
  double tmpy;
  for(int i=0;i<poccb;i++)
  {
    tmpp=cb[i].get_x()/((double)mapa->sirka/cv_sloupcu);
    if((int)tmpp>=cv_sloupcu)
      tmpp=cv_sloupcu-1;
    tmpy=cb[i].get_y()/((double)mapa->vyska/cv_radku);
    if((int)tmpy==cv_radku)
      tmpy=cv_radku-1;
    pocbun[(int)tmpp][(int)tmpy]++;
  }
  //zjitn pot usecek v jednotlivch tercch
  for(int i=0;i<pocusec;i++)
  {
    tmpp=useck[i].bod1x/((double)mapa->sirka/cv_sloupcu);
    if((int)tmpp>=cv_sloupcu)
      tmpp=cv_sloupcu-1;
    tmpy=useck[i].bod1y/((double)mapa->vyska/cv_radku);
    if((int)tmpy==cv_radku)
      tmpy=cv_radku-1;
    pocusecek[(int)tmpp][(int)tmpy]++;
  }
  //alokace tverc pro body
  int*** bodctver=new int** [cv_sloupcu];
  for(int i=0;i<cv_sloupcu;i++)
  {
    bodctver[i]=new int* [cv_radku];
    for(int j=0;j<cv_radku;j++)
    {
      bodctver[i][j]=new int [ pocbun[i][j]];
    }
  }
  for(int i=0;i<cv_sloupcu;i++)
  {
    for(int j=0;j<cv_radku;j++)
      pocbun[i][j]=0;
  }
  //alokace tverc pro useky
  int*** usecctver=new int** [cv_sloupcu];
  for(int i=0;i<cv_sloupcu;i++)
  {
    usecctver[i]=new int* [cv_radku];
    for(int j=0;j<cv_radku;j++)
    {
      usecctver[i][j]=new int [pocusecek[i][j]];
    }
  }
  for(int i=0;i<cv_sloupcu;i++)
  {
    for(int j=0;j<cv_radku;j++)
      pocusecek[i][j]=0;
  }
  bool t;
  //naten bod v jednotlivch tvercch
  for(int i=0;i<poccb;i++)
  {
    tmpp=cb[i].get_x()/((double)mapa->sirka/cv_sloupcu);
    if((int)tmpp>=cv_sloupcu)
      tmpp=cv_sloupcu-1;
    tmpy=cb[i].get_y()/((double)mapa->vyska/cv_radku);
    if((int)tmpy>=cv_radku)
      tmpy=cv_radku-1;
    t=true;
    for(int k=0;k<pocbun[(int)tmpp][(int)tmpy];k++)
    {
      if(cb[i]==cb[bodctver[(int)tmpp][(int)tmpy][k]])
      {
        poccb--;
        cb[i]=cb[poccb];
        t=false;
        i--;
        break;
      }
    }
    if(t)
    {
      bodctver[(int)tmpp][(int)tmpy][ pocbun[(int)tmpp][(int)tmpy]]=i;
      pocbun[(int)tmpp][(int)tmpy]++;
    }
  }

  //naten usecek v jednotlivch tvercch
  for(int i=0;i<pocusec;i++)
  {
    tmpp=useck[i].bod1x/((double)mapa->sirka/cv_sloupcu);
    if((int)tmpp>=cv_sloupcu)
      tmpp=cv_sloupcu-1;
    tmpy=useck[i].bod1y/((double)mapa->vyska/cv_radku);
    if((int)tmpy>=cv_radku)
      tmpy=cv_radku-1;
    usecctver[(int)tmpp][(int)tmpy][ pocusecek[(int)tmpp][(int)tmpy]]=i;
    pocusecek[(int)tmpp][(int)tmpy]++;
  }
  //alokace 9 tvercovch oblast pomocnch, v okol hledan vky
  int** tempbod=new int* [9];
  int** tempusec=new int* [9];
  int poctempbod[9];
  int temppocusecek[9];
  int pametx=1 ;
  int pamety=1 ;

  tmpp=1;
  tmpy=1;
  for(int i=0;i<3;i++) //naplnn pomocnch tverc
  {
    for(int j=0;j<3;j++)
    {
      tempusec[i*3+j]=usecctver[i+(int)tmpp-1][j+(int)tmpy-1];
      temppocusecek[i*3+j]=pocusecek[i+(int)tmpp-1][j+(int)tmpy-1];
      tempbod[i*3+j]=bodctver[i+(int)tmpp-1][j+(int)tmpy-1];
      poctempbod[i*3+j]=pocbun[i+(int)tmpp-1][j+(int)tmpy-1];
    }
  }
  Tpoint temppoint;
  // vlastn program
  for(int l=0;l<rad;l++) //prochz body st
  {
    (*P)();
    for(int m=0;m<slp;m++)
    {
      b=false;
      for(int g=0;g<pp;g++) //inicializace pomocnch promnnch
      {
        vv1[g]=0;
        s1[g]=100000;
        bodcislo[g]=-1 ;
      }
      //zjitn aktulnho tverce
      tmpp=(m*xscale)/((double)mapa->sirka/cv_sloupcu);
      if((int)tmpp>=cv_sloupcu-1)    tmpp=cv_sloupcu-2;
      if((int)tmpp==0)    tmpp=1;
      tmpy=(l*yscale)/((double)mapa->vyska/cv_radku);
      if((int)tmpy>=cv_radku-1)     tmpy=cv_radku-2;
      if((int)tmpy==0)     tmpy=1;
      //nacteni bod v tvercch okolo hledan vsky
      if(pametx!=tmpp || pamety!=tmpy)
      {
        pametx=tmpp;
        pamety=tmpy;
        for(int i=0;i<3;i++)
        {
          for(int j=0;j<3;j++)
          {
            tempusec[i*3+j]=usecctver[i+(int)tmpp-1][j+(int)tmpy-1];
            temppocusecek[i*3+j]=pocusecek[i+(int)tmpp-1][j+(int)tmpy-1];
            tempbod[i*3+j]=bodctver[i+(int)tmpp-1][j+(int)tmpy-1];
            poctempbod[i*3+j]=pocbun[i+(int)tmpp-1][j+(int)tmpy-1];
          }
        }
      }
      //zjitn prazdnoty oblasti
      tmpp=0;
      for(int r=0;r<9;r++)
      {
        tmpp=tmpp+poctempbod[r]+temppocusecek[r];

      }
      //test v dan oblasti nen ani bod ani vrstevnice
      if(tmpp==0)
      {
        vys[l][m]=(vmax-vmin)/2.0+vmin;
        b=true;
        continue;
      }
      //Najdi nejblis vrstevnici
      for(int r=0;r<9;r++)
      {
        for(int q=0;q<temppocusecek[r];q++)
        {
          del=dist_Point_to_Segment( Tpoint(m*xscale,l*yscale),Tpoint(useck[tempusec[r][q]].bod1x,useck[tempusec[r][q]].bod1y),Tpoint(useck[tempusec[r][q]].bod2x,useck[tempusec[r][q]].bod2y)) ;
          if(del<s1[0])
          {
            s1[0]=del;
            vv1[0]=useck[tempusec[r][q]].vyska;
            bodcislo[0]=tempusec[r][q];
            if ((int)s1[0]==0)
            {
              vys[l][m]=useck[tempusec[r][q]].vyska;
              b=true;
              break;
            }
          }
        }
        if(b)  break;
      }
      if(b==false)
      {
        //Najdi nejbli bod-samostatn
        for(int r=0;r<9;r++)
        {
          if(b) break;
          for(int q=0;q<poctempbod[r];q++)
          {
            del=cb[tempbod[r][q]].Vzdalenost(m*xscale,l*yscale);
            if((int)del==0)
            {
              vys[l][m]=cb[tempbod[r][q]].get_z();
              b=true;
              break;
            }
            if(del<s1[2])
            {
              s1[2]=del;
              vv1[2]=cb[tempbod[r][q]].get_z();
              bodcislo[2]=tempbod[r][q];
            }
          }
          if(b) break;
        }

      }
      if(b==false)
      {
        //Najdi 2. nejbli vrstevnici

        int f ;
        for(int r=0;r<9;r++)
        {
          for(int q=0;q<temppocusecek[r];q++)
          {
            if(abs(vv1[0]-useck[tempusec[r][q]].vyska)>ekv) continue;
            if(vv1[0]==useck[tempusec[r][q]].vyska)continue; //vrstevnice m sterjnou vku
            if(bodcislo[0]==tempusec[r][q]) continue;   //stejn vrstevnice
            del=dist_Point_to_Segment( Tpoint(m*xscale,l*yscale),Tpoint(useck[tempusec[r][q]].bod1x,useck[tempusec[r][q]].bod1y),Tpoint(useck[tempusec[r][q]].bod2x,useck[tempusec[r][q]].bod2y)) ;
            if(del<s1[1])
            {
              temppoint= Point_to_Segment( Tpoint(m*xscale,l*yscale),Tpoint(useck[tempusec[r][q]].bod1x,useck[tempusec[r][q]].bod1y),Tpoint(useck[tempusec[r][q]].bod2x,useck[tempusec[r][q]].bod2y)) ;

              f=0;
              // zjisti zda mezi aktuln vrstvnic a bodem pro kter hledme vku nen jin vrstevnice
              for(int r1=0;r1<9;r1++)
              {
                if(f!=0)break;
                for(int q1=0;q1<temppocusecek[r1];q1++)
                {
                  if(tempusec[r1][q1]==tempusec[r][q])continue;
                  f= intersect( TPoint(m*xscale,l*yscale), temppoint,
                                Tpoint(useck[tempusec[r1][q1]].bod1x,useck[tempusec[r1][q1]].bod1y),Tpoint(useck[tempusec[r1][q1]].bod2x,useck[tempusec[r1][q1]].bod2y));
                  if(f!=0 && f!=-2 )
                  {

                    break;
                  }
                }
              }
              if(f==0 || f==-2)
              {                 //dn ken nenalezeno
                s1[1]=del;
                vv1[1]=useck[tempusec[r][q]].vyska;
                bodcislo[1]=tempusec[r][q];
              }
            }

          }
        }
        //jestlie vzdlenost mezi vkovm bodem a 2. nejbli vrstevnic
        //je vt nez vzdlenost mezi vkovm bodem a samostatncm bodem
        //zjisti zda nezi nm a bodem vkovm le njak vrstevnice
        if((bodcislo[1]==-1 || (bodcislo[1]!=-1 && s1[1]>s1[2])) && bodcislo[0]!=-1 )
        {
          f=0;
          for(int r1=0;r1<9;r1++)
          {
            for(int q1=0;q1<temppocusecek[r1];q1++)
              
            {
              f= intersect( TPoint(m*xscale,l*yscale),cb[bodcislo[2]] ,
                            Tpoint(useck[tempusec[r1][q1]].bod1x,useck[tempusec[r1][q1]].bod1y),Tpoint(useck[tempusec[r1][q1]].bod2x,useck[tempusec[r1][q1]].bod2y));
              if(f!=0)
              {

                break;
              }
            }
            if(f!=0)break;
          }
          if(f==0)
          {
            //dn vrstevnice nenalezena
            bodcislo[1]=bodcislo[2];
            vv1[1]=vv1[2];
            s1[1]=s1[2];
          }
        }
        if(bodcislo[1]!=-1 )
        { //vpoet hledan vky
          vys[l][m]=-(vv1[0]-vv1[1])/(s1[1]+s1[0])*s1[0]+vv1[0];
        }
        else
          vys[l][m]=vv1[0];  //vkov bod le na vrstevnici nebo samostatnm bod
      }
    }
  }
  delete[] cb;
  delete[] useck;
  delete[] pocbun;
  delete[] pocusecek;
  delete[] bodctver ;
  delete[] usecctver;
  delete[] tempbod;
  delete[] tempusec;

}

//===================================================================
// cn_PnPoly(): crossing number test for a point in a polygon
//      Input:   P = a point,
//               V[] = vertex points of a polygon V[n+1] with V[n]=V[0]
//      Return:  0 = outside, 1 = inside
// This code is patterned after [Franklin, 2000]
//funkce pevzata
int
cn_PnPoly( TPoint P, TPoint A ,TPoint B,TPoint C)
{
  int    cn = 0;    // the crossing number counter
  // loop through all edges of the polygon
  //   for (int i=0; i<3; i++) {    // edge from A to B
  if (((A.y <= P.y) && (B.y > P.y))    // an upward crossing
      || ((A.y > P.y) && (B.y <= P.y)))
  { // a downward crossing
    // compute the actual edge-ray intersect x-coordinate
    float vt = (float)(P.y - A.y) / (B.y - A.y);
    if (P.x < A.x + vt * (B.x - A.x)) // P.x < intersect
      ++cn;   // a valid crossing of y=P.y right of P.x
  }
  // }
  if (((B.y <= P.y) && (C.y > P.y))    // an upward crossing
      || ((B.y > P.y) && (C.y <= P.y)))
  { // a downward crossing
    // compute the actual edge-ray intersect x-coordinate
    float vt = (float)(P.y - B.y) / (C.y - B.y);
    if (P.x < B.x + vt * (C.x - B.x)) // P.x < intersect
      ++cn;   // a valid crossing of y=P.y right of P.x
  }
  if (((C.y <= P.y) && (A.y > P.y))    // an upward crossing
      || ((C.y > P.y) && (A.y <= P.y)))
  { // a downward crossing
    // compute the actual edge-ray intersect x-coordinate
    float vt = (float)(P.y - C.y) / (A.y - C.y);
    if (P.x < C.x + vt * (A.x - C.x)) // P.x < intersect
      ++cn;   // a valid crossing of y=P.y right of P.x
  }
  return (cn&1);    // 0 if even (out), and 1 if odd (in)
}
//===================================================================
//funkce pro zjitn zda v danm tjoujhelnku nele njak bod
//cb - seznam souadnic
//bod - seznam bod v jednotliv tvercch
//poc - pole s potem bod v jednotlivch tvercch
//A,B,C - sla bod reprezentujc tverce

bool TestClear(  Hbod3D* cb,int** bod,int* poc  , int A ,int B,int C)
{
  for(int r=0;r<9;r++)
    for(int p=0;p<poc[r];p++)
  // for(int w=0;w<n;w++)
  {
    if(bod[r][p]==A || bod[r][p]==B || bod[r][p]==C)continue;
    if(cn_PnPoly(cb[bod[r][p]],cb[A],cb[B],cb[C])==1)return false;
  }
  return true;
}
//===================================================================
//test zda nov tvoen seky novho trojhelnku se nek s njakou vrstevnic
//C1,C2,CC sla bod nov tvoenho trojhelnka
//useck - pole kde jsou uloeny seky tvoc vrstevnice
//usectver - vrstevnice ve tvercch okolo trojhelnku
//uspoc - poet sek vrstenic v jednotlivch tvercch
bool Test_inter (TPoint C1,TPoint C2,TPoint CC , Husecka* useck,int** usctver ,int* uspoc )
{
  int stav;
   for(int r=0;r<9;r++)
    for(int j=0;j<uspoc[r];j++)
  {
    stav= intersect(C1,CC,TPoint(useck[usctver[r][j]].bod1x,useck[usctver[r][j]].bod1y),TPoint(useck[usctver[r][j]].bod2x,useck[usctver[r][j]].bod2y)) ;
    if(stav==-5||stav==1)return false;
    stav= intersect(C2,CC,TPoint(useck[usctver[r][j]].bod1x,useck[usctver[r][j]].bod1y),TPoint(useck[usctver[r][j]].bod2x,useck[usctver[r][j]].bod2y)) ;
    if(stav==-5||stav==1)return false;
  }
  //   }
  // }
  return true;
}
//===================================================================
// teset zda bod A je ve stejn polorovin jako bod B
//rovina je dlena pmkou na kter le body P,K
bool StejnaStrana1(TPoint P,TPoint K,TPoint A,TPoint B)
{
  if((K.x==A.x && K.y==A.y)||(K.x==B.x && K.y==B.y))return true;
  double   a1=(K.x-P.x)/sqrt((P.x-K.x)*(P.x-K.x)+(P.y-K.y)*(P.y-K.y));
  double   a2=(K.y-P.y)/sqrt((P.x-K.x)*(P.x-K.x)+(P.y-K.y)*(P.y-K.y));
  double Z1= a2*(A.x-P.x)-a1*(A.y-P.y);
  double Z2= a2*(B.x-P.x)-a1*(B.y-P.y);
  if(Z1*Z2>=0)return true;
  return false;
}
//===================================================================
//funkce kter vrac hodnotu kritria pro nejvodn bod novho trojhelnku
//A,B body trojhelnku
//C - testovan nov bod
inline double Kriterium(TPoint A,TPoint B,TPoint C)
{
  double s1=sqrt((A.x-B.x)*(A.x-B.x)+(A.y-B.y)*(A.y-B.y));
  double s2=sqrt((A.x-C.x)*(A.x-C.x)+(A.y-C.y)*(A.y-C.y));
  // double s3=sqrt((C.x-B.x)*(C.x-B.x)+(C.y-B.y)*(C.y-B.y));
  // double f=(s1+s2+s3)/3;
  //return fabs(f-s1)+fabs(f-s2)+fabs(f-s3);
  // return fabs(s1-s2);
  return s1+s2;
}
//===================================================================
//test zda nov tvoen seky novho trojhelnku se nek s jinmi sekami trojhelnk
//c1,c2,c3 sla bod starho trojhelnka
//katalog - seznam spojnic tvocch trojhelnky
//cb - seznam souadnic
//cc - testovan bod
bool TestKriz(Hbod3D* cb,int c1,int c2,int c3,int cc,katalog_dvoj* katalog)
{
  int a2;

  for(int i=0;i<katalog[c1].get_pocet();i++)
  {
    a2=katalog[c1].dv[i];
    if(a2==c2 ||a2==c3)continue;
    if(!StejnaStrana1(cb[c1],cb[c2],cb[c3],cb[a2]))
    {
      if(!StejnaStrana1(cb[c1],cb[a2],cb[c2],cb[cc]))
      {
        return false;
      }
    }
  }

  for(int i=0;i<katalog[c2].get_pocet();i++)
  {
    a2=katalog[c2].dv[i];
    if(a2==c1 ||a2==c3)continue;
    if(!StejnaStrana1(cb[c1],cb[c2],cb[c3],cb[a2]))
    {
      if(!StejnaStrana1(cb[c2],cb[a2],cb[c1],cb[cc]))
      {
        return false;
      }
    }
  }

  return true;
}
//------------------------------------------------------------------------------
//===================================================================
// orientation2D_Triangle(): test the orientation of a triangle
//    Input:  three vertex points V0, V1, V2
//    Return: >0 for counterclockwise
//            =0 for none (degenerate)
//            <0 for clockwise
//funkce pevzata
int orientation2D_Triangle( troj t ,Hbod3D* v)
{
  return isLeft(v[t.get_c1()],v[t.get_c2()], v[t.get_c3()]);
}
//===================================================================
//funkce pro tvorbu trojhelnkov st
//mapa - tda s definic vrstevnic a samostatnch bod pro kterou se generuje trojhelnkov s
//interval - interval vrstevnic poutch pro generovn st
//(*P) - ukazatel na funkci, kter se vol v prbhu funkce pro informaci hlavnho programu o rychlosti prbhu

int Mnozina_ploch(Hmapa *mapa,mapa_troj& tr , void(*P)(),int interval=1)
{

  int pocet=0,poctroj=0,pocspoj=0;
  int pocusec=0;
  //potn bod
  for(int i=0;i<mapa->get_pocetcar();i++)
  {
    if(mapa->get_pocetbodu_nacare(i)<2 || mapa->get_vyska(i)==-1)continue;
    if((mapa->get_vyska(i)%interval)!=0)continue;
    pocet=pocet+mapa->get_pocetbodu_nacare(i);
  }
  pocusec=pocet-mapa->get_pocetcar();

  pocet=pocet+mapa->Get_pocet3D();
  if(pocet<4){ShowMessage("nedostatek Bod");return 0;}
  //alokace prostoru
    pocet=pocet*3;
  troj* trojuhelnik = new troj[pocet];
  Hbod3D* cb = new Hbod3D[pocet/3];
  Husecka* useck = new Husecka[pocusec];
  dvoj* spojnice = new dvoj[pocet*3];
  int  poccb=0;
  pocusec = 0;
  //natn bod a vrstevnic
  for(int i=0;i<mapa->get_pocetcar();i++)
  {
    if(mapa->get_pocetbodu_nacare(i)<2 || mapa->get_vyska(i)==-1)continue;
    if((mapa->get_vyska(i)%interval)!=0)continue;
    for(int j=0;j<mapa->get_pocetbodu_nacare(i);j++)
    {

      cb[poccb].Pridej(mapa->get_bod(i,j),mapa->get_vyska(i));
      if(mapa->vyska<cb[poccb].get_y())ShowMessage("chyba 16");
      if(mapa->sirka<cb[poccb].get_x())ShowMessage("chyba 17");
      if(j!=0 ) useck[pocusec].set(cb[poccb-1],cb[poccb]);
      poccb++;
      if(j!=0) pocusec++;
    }
  }

  //natn samostatnch bod
  for(int i=0;i<mapa->Get_pocet3D();i++)
  {
    cb[poccb]=(*mapa)[i];
    if(mapa->vyska<cb[poccb].get_y())ShowMessage("chyba 18");
    if(mapa->sirka<cb[poccb].get_x())ShowMessage("chyba 19");
    for(int k=0;k<poccb;k++)
    {
      if(cb[poccb]==cb[k])
      {
        poccb--;
        break;
      }
    }
    poccb++;
  }
  //vpoet potu tverc
  int pocet_ctvercu=poccb/50;
  double tmpp= sqrt(mapa->vyska*pocet_ctvercu/mapa->sirka);
  int cv_radku=(tmpp-(int)tmpp)>0.5?ceil(tmpp):floor(tmpp);
  if(cv_radku<3) cv_radku=3;
  tmpp= sqrt(mapa->sirka*pocet_ctvercu/mapa->vyska);
  int cv_sloupcu=(tmpp-(int)tmpp)>0.5?ceil(tmpp):floor(tmpp);
  if( cv_sloupcu<3)  cv_sloupcu=3;
  //alokace promnn pro poet bod ve tvercch
  int** pocbun = new int* [cv_sloupcu];
  for(int i=0;i<cv_sloupcu;i++)
  {
    pocbun[i]= new int [cv_radku];
    for(int j=0;j<cv_radku;j++)
      pocbun[i][j]=0;
  }
  //alokace promnn pro poet usecek ve tvercch
  int** pocusecek = new int* [cv_sloupcu];
  for(int i=0;i<cv_sloupcu;i++)
  {
    pocusecek[i]= new int [cv_radku];
    for(int j=0;j<cv_radku;j++)
      pocusecek[i][j]=0;
  }
  //zjitn pot bod v jednotlivch tercch
  double tmpy;
  for(int i=0;i<poccb;i++)
  {
    tmpp=cb[i].get_x()/((double)mapa->sirka/cv_sloupcu);
    if((int)tmpp>=cv_sloupcu)
      tmpp=cv_sloupcu-1;
    tmpy=cb[i].get_y()/((double)mapa->vyska/cv_radku);
    if((int)tmpy==cv_radku)
      tmpy=cv_radku-1;
    pocbun[(int)tmpp][(int)tmpy]++;
  }
  //zjitn pot useek v jednotlivch tercch
  for(int i=0;i<pocusec;i++)
  {
    tmpp=useck[i].bod1x/((double)mapa->sirka/cv_sloupcu);
    if((int)tmpp>=cv_sloupcu)
      tmpp=cv_sloupcu-1;
    tmpy=useck[i].bod1y/((double)mapa->vyska/cv_radku);
    if((int)tmpy==cv_radku)
      tmpy=cv_radku-1;
    pocusecek[(int)tmpp][(int)tmpy]++;
  }
  //alokace tverc
  int*** bodctver=new int** [cv_sloupcu];
  for(int i=0;i<cv_sloupcu;i++)
  {
    bodctver[i]=new int* [cv_radku];
    for(int j=0;j<cv_radku;j++)
    {
      bodctver[i][j]=new int [ pocbun[i][j]];
    }
  }
  for(int i=0;i<cv_sloupcu;i++)
  {
    for(int j=0;j<cv_radku;j++)
      pocbun[i][j]=0;
  }
  //alokace tverc pro useky
  int*** usecctver=new int** [cv_sloupcu];
  for(int i=0;i<cv_sloupcu;i++)
  {
    usecctver[i]=new int* [cv_radku];
    for(int j=0;j<cv_radku;j++)
    {
      usecctver[i][j]=new int [pocusecek[i][j]];
    }
  }
  for(int i=0;i<cv_sloupcu;i++)
  {
    for(int j=0;j<cv_radku;j++)
      pocusecek[i][j]=0;
  }
  bool t;
  //naten bod v jednotlivch tvercch
  for(int i=0;i<poccb;i++)
  {
    tmpp=cb[i].get_x()/((double)mapa->sirka/cv_sloupcu);
    if((int)tmpp>=cv_sloupcu)
      tmpp=cv_sloupcu-1;
    tmpy=cb[i].get_y()/((double)mapa->vyska/cv_radku);
    if((int)tmpy>=cv_radku)
      tmpy=cv_radku-1;
    t=true;
    //kontrola duplicity bod
    for(int k=0;k<pocbun[(int)tmpp][(int)tmpy];k++)
    {
      if(cb[i]==cb[bodctver[(int)tmpp][(int)tmpy][k]])
      {
        poccb--;
        cb[i]=cb[poccb];
        t=false;
        i--;
        break;
      }
    }
    if(t)
    {
      bodctver[(int)tmpp][(int)tmpy][ pocbun[(int)tmpp][(int)tmpy]]=i;
      pocbun[(int)tmpp][(int)tmpy]++;
    }
  }
  //naten usecek v jednotlivch tvercch
  for(int i=0;i<pocusec;i++)
  {
    tmpp=useck[i].bod1x/((double)mapa->sirka/cv_sloupcu);
    if((int)tmpp>=cv_sloupcu)
      tmpp=cv_sloupcu-1;
    tmpy=useck[i].bod1y/((double)mapa->vyska/cv_radku);
    if((int)tmpy>=cv_radku)
      tmpy=cv_radku-1;
    usecctver[(int)tmpp][(int)tmpy][ pocusecek[(int)tmpp][(int)tmpy]]=i;
    pocusecek[(int)tmpp][(int)tmpy]++;
  }
  //alokace 9 tvercovch oblast
  int** tempbod=new int* [9];
  int** tempusec=new int* [9];
  int poctempbod[9];
  int temppocusecek[9];
  for(int i=0;i<3;i++)
  {
    for(int j=0;j<3;j++)
    {
      tempusec[i*3+j]=usecctver[i-1+(cv_sloupcu-1)/2][j-1+(cv_radku-1)/2];
      temppocusecek[i*3+j]=pocusecek[i-1+(cv_sloupcu-1)/2][j-1+(cv_radku-1)/2];
      tempbod[i*3+j]=bodctver[i-1+(cv_sloupcu-1)/2][j-1+(cv_radku-1)/2];
      poctempbod[i*3+j]=pocbun[i-1+(cv_sloupcu-1)/2][j-1+(cv_radku-1)/2];
    }
  }
  int pametx=(cv_sloupcu-1)/2 ;
  int pamety=(cv_radku-1)/2;
  katalog_dvoj* sez_dvoj=new  katalog_dvoj[poccb];

  int c1,c2,c3;
  float del=999999999;
  //Hledn 1. bodu 1. trojhelnka
  for(int r=0;r<9;r++)
    for(int p=0;p<poctempbod[r];p++)
  {
    if(del>cb[tempbod[r][p]].Vzdalenost(mapa->sirka/2,mapa->vyska/2))
    {
      c1=tempbod[r][p];
      del=cb[tempbod[r][p]].Vzdalenost(mapa->sirka/2,mapa->vyska/2);
    }
  }
  //Hledn 2. bodu
  del=999999999;
  for(int r=0;r<9;r++)
    for(int p=0;p<poctempbod[r];p++)
  {
    if(tempbod[r][p]==c1)continue;
    if(del>cb[tempbod[r][p]].Vzdalenost(cb[c1]))
    {
      c2=tempbod[r][p];
      del=cb[tempbod[r][p]].Vzdalenost(cb[c1]);
    }
  }
  //Hledn 3. bodu
  float d1=cb[c1].Vzdalenost(cb[c2]);
  del=999999999;
  for(int r=0;r<9;r++)
    for(int p=0;p<poctempbod[r];p++)
  {
    if(tempbod[r][p]==c1 || tempbod[r][p]==c2)continue;
    if(del>fabs(d1-cb[tempbod[r][p]].Vzdalenost(cb[c1])-cb[tempbod[r][p]].Vzdalenost(cb[c2])))
    {
      if(TestClear(cb,tempbod,poctempbod,c1,c2,tempbod[r][p])==true )
      {
        if(Test_inter (cb[c1],cb[c2],cb[tempbod[r][p]],useck,tempusec,temppocusecek   ))
        {
          c3=tempbod[r][p];
          del=fabs(d1-cb[tempbod[r][p]].Vzdalenost(cb[c1])-cb[tempbod[r][p]].Vzdalenost(cb[c2]));
        }
      }
    }
  }
 //test zda v prvnm trojhelnku nele nejak bod
  for(int r=0;r<9;r++)
    for(int p=0;p<poctempbod[r];p++)
  {
    if(tempbod[r][p]==c1 || tempbod[r][p]==c2 || tempbod[r][p]==c3)continue;
    if(cn_PnPoly(cb[tempbod[r][p]],cb[c1],cb[c2],cb[c3])==1)ShowMessage("Chyba 1");
  }
  //uloen 1. trojhelnku
  spojnice[pocspoj].Pridej(c1,c2,0);
  sez_dvoj[c1].Pridej(c2,pocspoj);
  sez_dvoj[c2].Pridej(c1,pocspoj);
  pocspoj++;
  spojnice[pocspoj].Pridej(c2,c3,0);
  sez_dvoj[c2].Pridej(c3,pocspoj);
  sez_dvoj[c3].Pridej(c2,pocspoj);
  pocspoj++;
  spojnice[pocspoj].Pridej(c3,c1,0);
  sez_dvoj[c3].Pridej(c1,pocspoj);
  sez_dvoj[c1].Pridej(c3,pocspoj);
  pocspoj++;
  trojuhelnik[poctroj].Pridej(c1,c2,c3);
  poctroj++;
  int cc;
  float kritvel=(min(mapa->vyska,mapa->sirka))/10;

  float krt;
  int inteligent=0;
  float omez;
  //Vlastni program

  int p;
  for(int s=0;s<poctroj && poctroj<pocet;s++)
  {
    (*P)();
    for(int t=0;t<3 && poctroj<pocet;t++)
    {

      if(trojuhelnik[s].get_troj(t)!=-1) continue;     //strana je jiz opsazena
      trojuhelnik[s].get_c(t,c1,c2,c3);        //zskn bod v trojhelnku
      del=999999999;
      cc=-1;
      if(inteligent>1)
      {
        kritvel=kritvel*1.3;
        inteligent=0;
      }
      if(inteligent<-300)
      {
        kritvel=kritvel*0.8;
        if(kritvel<10)kritvel=10;
        inteligent=0;
      }
      //naten tverc v okol trojhelnku
      tmpp=((cb[c1].get_x()+cb[c2].get_x())/2)/((double)mapa->sirka/cv_sloupcu);
      if((int)tmpp>=cv_sloupcu-1)    tmpp=cv_sloupcu-2;
      if((int)tmpp==0)    tmpp=1;
      tmpy=((cb[c1].get_y()+cb[c2].get_y())/2)/((double)mapa->vyska/cv_radku);
      if((int)tmpy>=cv_radku-1)     tmpy=cv_radku-2;
      if((int)tmpy==0)     tmpy=1;
      if(pametx!=tmpp || pamety!=tmpy)
      {
        pametx=tmpp;
        pamety=tmpy;
        for(int i=0;i<3;i++)
        {
          for(int j=0;j<3;j++)
          {
            tempusec[i*3+j]=usecctver[i+(int)tmpp-1][j+(int)tmpy-1];
            temppocusecek[i*3+j]=pocusecek[i+(int)tmpp-1][j+(int)tmpy-1];
            tempbod[i*3+j]=bodctver[i+(int)tmpp-1][j+(int)tmpy-1];
            poctempbod[i*3+j]=pocbun[i+(int)tmpp-1][j+(int)tmpy-1];
          }
        }
      }
      krt=kritvel;
      //prochzen bod pi hledn
      for(int r=0;r<9;r++)
      {
        for(int q=0;q<poctempbod[r];q++)
        {
          p=tempbod[r][q];
          //hledn vrcholu novho trojhelnku
          if(!(p==c1 || p==c2 || p==c3))
          {
            //vynechn bod trojhelnku
            omez=cb[p].Vzdalenost(cb[c1])+cb[p].Vzdalenost(cb[c2]);
            if(omez<krt)
            {
              if(StejnaStrana1(cb[c1],cb[c2],cb[c3],cb[p])==false)
              {    //zjitn kontrola polorovniny bodu
                d1=   Kriterium(cb[p],cb[c1],cb[c2]);
                if(cb[p].get_z()==cb[c1].get_z() && cb[c1].get_z()==cb[c2].get_z() && cb[c2].get_z()==cb[p].get_z())
                  d1=d1*2;
                if(del>d1)
                {
                  if(TestClear(cb,tempbod,poctempbod,c1,c2,p)==true ) //kontrola przdnoty novho trojhelnka
                  {
                    if(TestKriz(cb,c1,c2,c3,p,sez_dvoj)) //kontrola krizen trojuheliku
                    {                //test krizeni
                      if(Test_inter (cb[c1],cb[c2],cb[p] ,useck,tempusec,temppocusecek))//test vrstevnic
                      {
                        cc=p;
                        del=d1;
                      }
                    }
                  }
                }
              }
            }
          }
        }
        if(r==8  )
        {
          if(cc==-1   && krt==kritvel)
          {
            
            r=-1;
            krt=999999999;
            inteligent++;
          }
          else if( krt==kritvel )inteligent--;
        }
      }
      if(cc!=-1)
      {   //uloen nalezenho trojhelnku
        bool s1=false,s2=false;
        trojuhelnik[poctroj].Pridej(c1,c2,cc,s);
        trojuhelnik[s].Dodej(c1,c2,poctroj);
        for(int o=0;o<sez_dvoj[c1].get_pocet();o++)
        {
          int op=sez_dvoj[c1].spoj[o];
          if(spojnice[op].Stejne(c1,cc))
          {
            spojnice[op].Dodej(cc);
            trojuhelnik[spojnice[op].get_tr1()].Dodej(c1,cc,poctroj);
            trojuhelnik[poctroj].Dodej(c1,cc,spojnice[op].get_tr1());
            // poctroj++;
            s1=true;
            break;
          }
        }
        for(int o=0;o<sez_dvoj[c2].get_pocet();o++)
        {
          int op=sez_dvoj[c2].spoj[o];
          if(spojnice[op].Stejne(c2,cc))
          {
            spojnice[op].Dodej(cc);
            trojuhelnik[spojnice[op].get_tr1()].Dodej(c2,cc,poctroj);
            trojuhelnik[poctroj].Dodej(c2,cc,spojnice[op].get_tr1());
            //poctroj++;
            s2=true;
            break;
          }
        }
        if(!s1)
        {
          spojnice[pocspoj].Pridej(c1,cc,poctroj);
          sez_dvoj[cc].Pridej(c1,pocspoj);
          sez_dvoj[c1].Pridej(cc,pocspoj);
          pocspoj++;
        }
        if(!s2)
        {
          spojnice[pocspoj].Pridej(c2,cc,poctroj);
          sez_dvoj[c2].Pridej(cc,pocspoj);
          sez_dvoj[cc].Pridej(c2,pocspoj);
          pocspoj++;
        }
           poctroj++;
      }
      else   trojuhelnik[s].Dodej(c1,c2,-2);

    }
  }
  if( poctroj>=pocet)ShowMessage("Chyba");

  tr.Alloc(poctroj,poccb);
  for(int i=0;i<poctroj;i++)
    tr.triangl[i]=trojuhelnik[i];
  for(int i=0;i<poccb;i++)
    tr.bod[i]=cb[i];
  delete[] cb;
  delete[] trojuhelnik;
  delete[] spojnice;
  delete[] useck;
  delete[] sez_dvoj;
  delete[] pocbun;
  delete[] pocusecek;
  delete[] bodctver ;
  delete[] usecctver;
  delete[] tempbod;
  delete[] tempusec;
  return poctroj;
  //  ShowMessage("Hotovo");

}
//---------------------------------------------------------------------------
//metoda pro zjitn potu vech bod na map
int Hmapa::Pocet_vsech_bodu()
{
  int po=0;
  for(unsigned int i=0;i<pocetcar;i++)
  {
    po=po+cary[i].get_pocetbodu();
  }
  po=po+pocetbodu3D;
  return po;
}
//---------------------------------------------------------------------------
//funkce pro zjitn zda trojhelnk zasahuje do danho tverce
//c - pole se souadnicemi trojhelniku
//lh,ld,ph,pd souadnice rohovch bod tverce
bool in_ctver(Hbod2D* c,Hbod2D lh,Hbod2D ld,Hbod2D ph,Hbod2D pd)
{
  int f;
  for(int i=0;i<3;i++)
  {
    f=intersect(c[i%3],c[(i+1)%3],lh,ld);
    if(f!=0)return true;
    f=intersect(c[i%3],c[(i+1)%3],ld,pd);
    if(f!=0)return true;
    f=intersect(c[i%3],c[(i+1)%3],ph,pd);
    if(f!=0)return true;
    f=intersect(c[i%3],c[(i+1)%3],ph,lh);
    if(f!=0)return true;
  }
  return false;
}
//---------------------------------------------------------------------------
//funkce pro rozdlen trojhelnkov st do tevercovch oblast
//map_torj - seznam trojhelnk
//vyska,sirka - rozmry mapy
//poc_rad,int poc_slp  - poet dk a sloupc pro rozdlen mapy
//rozdel_troj - dvojrozmrn pole pro uloen trojhelnkovch oblast
void rozdel_troj( mapa_troj* map_troj,int vyska,int sirka,int poc_rad,int poc_slp,mapa_troj** rozdel_troj)
{
  //alokace pamti
  float tmpy=(vyska+1)/poc_rad,tmpx=(sirka+1)/poc_slp;
  int** poc_v_b=new int* [poc_slp];
  for(int i=0;i<poc_slp;i++)
  {
    poc_v_b[i]=new int[poc_rad];
    for(int j=0;j<poc_rad;j++)
    {
      poc_v_b[i][j]=0;
    }
  }
  int k=map_troj->poctroj*5/(poc_rad*poc_slp);
  if(k>map_troj->poctroj)k=map_troj->poctroj;

  int*** troj_v_b=new int** [poc_slp];
  for(int i=0;i<poc_slp;i++)
  {
    troj_v_b[i]=new int*[poc_rad];
    for(int j=0;j<poc_rad;j++)
    {
      troj_v_b[i][j]=new int[k];
    }
  }
  int slp1,slp2,slp3,rad1,rad2,rad3;
  Hbod2D t[3];
  //rozdlen trojhelnk
  for(int i=0;i<map_troj->poctroj;i++)
  {
    slp1= map_troj->bod[map_troj->triangl[i].get_c1()].get_x()/tmpx;
    rad1= map_troj->bod[map_troj->triangl[i].get_c1()].get_y()/tmpy;
    slp2= map_troj->bod[map_troj->triangl[i].get_c2()].get_x()/tmpx;
    rad2= map_troj->bod[map_troj->triangl[i].get_c2()].get_y()/tmpy;
    slp3= map_troj->bod[map_troj->triangl[i].get_c3()].get_x()/tmpx;
    rad3= map_troj->bod[map_troj->triangl[i].get_c3()].get_y()/tmpy;
    if((slp1==slp2 && slp2==slp3 && slp3==slp1) && (rad1==rad2 && rad2==rad3 && rad3==rad1))
    {

      troj_v_b[slp1][rad1][poc_v_b[slp1][rad1]]=i;
      poc_v_b[slp1][rad1]++;
    }
    else
    {
      for(int j=MIN(slp1,slp2,slp3);j<=MAX(slp1,slp2,slp3);j++)
      {
        for(int k=MIN(rad1,rad2,rad3);k<=MAX(rad1,rad2,rad3);k++)
        {
          map_troj->get_tr(i,t);
          if(in_ctver(t,Hbod2D(j*tmpx,k*tmpy),Hbod2D(j*tmpx,(k+1)*tmpy),Hbod2D((j+1)*tmpx,k*tmpy),Hbod2D((j+1)*tmpx,(k+1)*tmpy)))
          {
            troj_v_b[j][k][poc_v_b[j][k]]=i;
            poc_v_b[j][k]++;
          }

        }


      }
    }
  }
  int* tabul=new int[map_troj->pocbod];
  //naplnn pol trojhelnk
  int count;
  int a,b,c;
  int poct;
  for(int i=0;i<poc_slp;i++)
  {
    for(int j=0;j<poc_rad;j++)
    {
      for(int i=0;i<map_troj->pocbod;i++) tabul[i]=-1;
      count=0;
      poct=poc_v_b[i][j];
      rozdel_troj[i][j].Alloctr(poct);
      for(int k=0;k<poct;k++)
      {
        rozdel_troj[i][j].triangl[k]=map_troj->triangl[troj_v_b[i][j][k]];
        if(tabul[rozdel_troj[i][j].triangl[k].get_c1()]==-1)a=count++;
        else a=tabul[rozdel_troj[i][j].triangl[k].get_c1()];
        if(tabul[rozdel_troj[i][j].triangl[k].get_c2()]==-1)b=count++;
        else b=tabul[rozdel_troj[i][j].triangl[k].get_c2()];
        if(tabul[rozdel_troj[i][j].triangl[k].get_c3()]==-1)c=count++;
        else c=tabul[rozdel_troj[i][j].triangl[k].get_c3()];
        rozdel_troj[i][j].triangl[k].Pridej(a,b,c);

      }
      rozdel_troj[i][j].Allocbo(count);
      for(int k=0;k<map_troj->pocbod;k++)
      {
        rozdel_troj[i][j].bod[tabul[k]]=map_troj->bod[k];


      }
    }
  }


}
#endif
