//---------------------------------------------------------------------------
//pomocn knihovna
//obsahuje knihovnu td sloucch pro generovn VRML souboru
//napsal Jan Havrlnat jako soust diplomov prce
//--Automatizovan tvorba prostorovch model map--
//v roce 2002
//---------------------------------------------------------------------------

#include <vcl.h>
#include <fstream.h>
#pragma hdrstop
#include "vrmlform.h"
#include "vrml.cpp"

//---------------------------------------------------------------------------

#pragma package(smart_init)

void vrml_file::Print (ofstream &soubor)//metoda pro vstup jednotlivch VRML uzl do souboru
{
  soubor<<"#VRML V2.0 utf8 "<<endl;
  for(int i=0;i<num;i++){
    node[i]->Print(soubor);
  }
}
//---------------------------------------------------------------------------
//metody pro sprvn vpis jednotlivch uzl VRML do souboru
void VRML_NAVIGATIONINFO::Print(ofstream &vrml)
{
  vrml.setf(ios::fixed);
  vrml.precision(2);
  vrml<<"NavigationInfo{"<<endl;
  if(avatarSize.x!=0.25 || avatarSize.y!=1.6 || avatarSize.z!=0.75)
    vrml<<"  avatarSize[ "<<avatarSize<<" ]"<<endl;
  if(!headlight)
    vrml<<"  headlight "<<headlight<<endl;
  if(speed!=1)
    vrml<<"  speed "<<speed<<endl;
  vrml<<"type ["<<type.c_str()<<"]"<<endl;
  vrml<<"}"<<endl;
}
//---------------------------------------------------------------------------
void VRML_BACKGROUND::Print(ofstream &vrml)
{
  vrml.setf(ios::fixed);
  vrml.precision(2);
  vrml<<"Background { "<<endl;
  if(pocet>0)
  {
    vrml<<"skyColor [ "<<endl;
    for(int i=0;i<pocet;i++)
    {
      vrml<<skyColor[i]<<endl;
    }
    vrml<<" ] ";
    vrml<<endl<<"skyAngle [ ";
    for(int i=0;i<pocet-1;i++)
    {
      vrml<<skyAngle[i]<<" ";
    }
    vrml<<" ] "<<endl;
  }
  if(pocet1>0)
  {
    vrml<<"groundColor [ ";
    for(int i=0;i<pocet1;i++)
    {
      vrml<<groundColor[i]<<endl;
    }
    vrml<<" ] "<<endl;
    vrml<<"groundAngle [ ";
    for(int i=0;i<pocet1-1;i++)
    {
      vrml<<groundAngle[i]<<endl;
    }
    vrml<<" ] "<<endl;
  }
  vrml<<"}"<<endl;
}
//---------------------------------------------------------------------------

void VRML_POINTLIGHT::Print(ofstream &vrml)
{
  vrml.precision(2);
  vrml.setf(ios::fixed);
  vrml<<"PointLight { "<<endl;
  if(location.x!=0 || location.y!=0 || location.z!=0)
    vrml<<"  location "<<location<<endl;
  if(radius!=100)
    vrml<<"  radius "<<radius<<endl;
  if(intensity!=1)
    vrml<<"intensity "<<intensity<<endl;
  if(ambientIntensity!=0)
    vrml<<"ambientIntensity "<<ambientIntensity<<endl;
  if(color.r!=1 || color.g!=1 || color.b!=1)
    vrml<<"color "<<color<<endl;
  if(attenuation.x!=1 || attenuation.y!=0 || attenuation.z!=0)
    vrml<<"attenuation "<<attenuation<<endl;
  vrml<<"} ";
}
//---------------------------------------------------------------------------

void VRML_VIEWPOINT::Print(ofstream &vrml )
{
  transform=vrml_Rotation(0,-1,0,0);
  orientation=vrml_Rotation(-1,0,0,0);
  transform.r=M_PI_2+atan2(target.z-position.z,target.x-position.x);
  orientation.r=M_PI_2+atan2(target.y-position.y,sqrt((target.x-position.x)*(target.x-position.x)+(target.z-position.z)*(target.z-position.z))) ;
  vrml.precision(2);
  vrml.setf(ios::fixed);
  vrml<<"Transform {"<<endl;
  vrml<<"  rotation "<<transform<<endl;
  vrml<<"  children ["<<endl;
  vrml<<"  Viewpoint { "<<endl;
  if(position.x!=0 || position.y!=0 || position.z!=10)
    vrml<<"    position "<<position<<endl;
  if(fieldOfViev!=M_PI/4)
    vrml<<"    fieldOfView "<<fieldOfViev<<endl;
  if(orientation.x!=0 || orientation.y!=0 || orientation.z!=1 || orientation.r!=0)
    vrml<<"    orientation "<<orientation<<endl;
  if(description!="")
    vrml<<"    description \""<<description.c_str()<<"\""<<endl;
  vrml<<"  }]"<<endl<<"}"<<endl;
 }
//---------------------------------------------------------------------------
void VRML_FOG::Print(ofstream &vrml)
{
  vrml.precision(2);
  vrml.setf(ios::fixed);
  vrml<<"Fog {"<<endl;
  if(color.r!=1 || color.b!=1 || color.g!=1)
    vrml<<"color "<<color.r<<" "<<color.g<<" "<<color.b<<endl;
  if(fogType!="\"LINEAR\"")
    vrml<<"fogType "<<fogType.c_str()<<endl;
  if(visibilityRange!=0)
    vrml<<"visibilityRange "<<visibilityRange<<endl;
  vrml<<"}"<<endl;
}
//---------------------------------------------------------------------------
void VRML_ELEVATIONGRID::Print(ofstream &vrml)
{
  vrml.precision(2);
  vrml.setf(ios::fixed);
  vrml<<"ElevationGrid {"<<endl;
  if( creaseAngle!=0)
    vrml<<"  creaseAngle "<<creaseAngle<<endl;
  if(!solid)
    vrml<<"  solid   "<<solid<<endl;
  if(xSpacing!=1)
    vrml<<"  xSpacing "<<xSpacing<<endl;
  if(zSpacing!=1)
    vrml<<"  zSpacing "<<zSpacing<<endl;
  if(xDimension !=0 && zDimension !=0)
  {
    vrml<<"  xDimension "<<xDimension-slod<<endl;
    vrml<<"  zDimension "<<zDimension-radod<<endl;
    vrml<<"  height [ "<<endl;
    for(int i=radod;i<zDimension;i++)
    {
      for(int j=slod;j<xDimension;j++)
      {
        vrml<<height[i][j]<<" ";
      }
      vrml<<endl;
    }
    vrml<<"]";
  }
  vrml<<"}"<<endl;
}
//---------------------------------------------------------------------------

void VRML_MATERIAL::Print(ofstream &vrml)
{
  vrml<<"Material {"<<endl;
  if(diffuseColor.r!=0.8 || diffuseColor.g!=0.8 || diffuseColor.b!=0.8)
    vrml<<"  diffuseColor "<<diffuseColor.r<<" "<<diffuseColor.g<<" "<<diffuseColor.b<<endl;
  if(ambientIntensity!=0.2 )
    vrml<<"  ambientIntensity "<<ambientIntensity<<endl;
  vrml<<"}"<<endl;
}
//---------------------------------------------------------------------------

VRML_IMAGETEXTURE::VRML_IMAGETEXTURE(String a)
{
  url=new String[1];poceturl=1;url[0]=a;
}
//---------------------------------------------------------------------------

void VRML_IMAGETEXTURE::Print(ofstream &vrml)
{
  vrml<<"ImageTexture {  url ";
  if(poceturl==1)
  {
    vrml<< "\""<<url[0].c_str()<<"\" }"<<endl;
  }
  else
  {
    vrml<<"[";
    for(int i=0;i<poceturl;i++)
    {
      vrml<<"\""<<url[i].c_str()<<"\" ";
    }
    vrml<<"]}"<<endl;
  }
}
//---------------------------------------------------------------------------

void VRML_SHAPE::Print (ofstream &vrml)
{
  vrml<<"Shape {"<<endl;
  vrml<<"  appearance "<<endl;
  appearance->Print(vrml);
  vrml<<"geometry ";
  geometry->Print(vrml);
  vrml<<"}"<<endl;
}
//---------------------------------------------------------------------------

void VRML_INDEXEDFACESET::Print (ofstream &vrml)
{
  vrml<<"IndexedFaceSet {"<<endl;
  if(!ccw)
    vrml<<"ccw "<<ccw<<endl;
  if(creaseAngle!=0)
    vrml<<"creaseAngle "<<creaseAngle<<endl;
  if(!solid)
    vrml<<"solid "<<solid<<endl;
  vrml<<"  coord  Coordinate { ";
  vrml<<" point [";
  for(int v=0;v<num_coord;v++)
  {
    vrml<<coord[v].get_x()/zkresleni<<" "<<coord[v].get_z()<<" "<< coord[v].get_y()/zkresleni<<","<<endl;
  }
  vrml<<"] }"<<endl;
  vrml<<"coordIndex [ "<<endl;
  for(int v=0;v<num_troj;v++)
  {
    if( orientation2D_Triangle( mojetroj[v],coord)<0)
    {
      vrml<<mojetroj[v].get_c1()<<" "<<mojetroj[v].get_c2()<<" "<<mojetroj[v].get_c3()<<" -1,"<<endl;
    }
    else
      vrml<<mojetroj[v].get_c3()<<" "<<mojetroj[v].get_c2()<<" "<<mojetroj[v].get_c1()<<" -1,"<<endl;
  }
  vrml<<" ]    "<<endl;
  vrml<<"texCoord TextureCoordinate {"<<endl;
  vrml<<" point ["<<endl;
  vrml.precision(4);
  for(int v=0;v<num_coord;v++)
  {
    vrml<<(double)coord[v].get_x()/sirka<<" "<< 1-(double)coord[v].get_y()/vyska<<","<<endl;
  }
  vrml<<"]}"<<endl;
  vrml<<"}"<<endl;
}
//---------------------------------------------------------------------------

void VRML_TRANSFORM::Print (ofstream &vrml)
{
  vrml<<"Transform {"<<endl;
  if(center.x!=0 || center.y!=0 || center.z!=0)
    vrml<<"center "<<center<<endl;  //         0 0 0    # (-,)
  if(rotation.x!=0 || rotation.y!=0 || rotation.z!=1 || rotation.r !=0 )
    vrml<<"rotation "<<rotation<<endl;  //      0 0 1 0  # [-1,1],(-,)
  if(scale.x!=1 || scale.y!=1 || scale.z!=1)
    vrml<<"scale "<<scale<<endl;          //  1 1 1    # (0,)
  if(scaleOrientation.x!=0 || scaleOrientation.y!=0 || scaleOrientation.z!=1 || scaleOrientation.r !=0 )
    vrml<<"scaleOrientation "<<scaleOrientation<<endl; //0 0 1 0  # [-1,1],(-,)
  if(translation.x!=0 || translation.y!=0 || translation.z!=0)
    vrml<<"translation "<<translation<<endl;    // 0 0 0    # (-,)
  if(bboxCenter.x!=0 || bboxCenter.y!=0 || bboxCenter.z!=0)
    vrml<<"bboxCenter "<<bboxCenter<<endl;     //  0 0 0    # (-,)
  if(bboxSize.x!=-1 || bboxSize.y!=-1 || bboxSize.z!=-1)
    vrml<<"bboxSize "<<bboxSize<<endl;       // -1 -1 -1 # (0,) or -1,-1,-1
  vrml<<"children["<<endl;
  if(mum_children>0)
  {
    for(int i=0;i<mum_children;i++)
    {
      children[i]->Print(vrml) ;
    }
  }
  vrml<<"]}"<<endl;
}
//---------------------------------------------------------------------------

void VRML_GROUP::Print (ofstream &vrml)
{
  vrml<<"Group {"<<endl;
  if(bboxCenter.x!=0 || bboxCenter.y!=0 || bboxCenter.z!=0)
    vrml<<"bboxCenter "<<bboxCenter<<endl;     //  0 0 0    # (-,)
  if(bboxSize.x!=-1 || bboxSize.y!=-1 || bboxSize.z!=-1)
    vrml<<"bboxSize "<<bboxSize<<endl;       // -1 -1 -1 # (0,) or -1,-1,-1
  if(mum_children>0)
  {
    for(int i=0;i<mum_children;i++)
    {
      children[i]->Print(vrml) ;
    }
  }
  vrml<<"}"<<endl;
}
//---------------------------------------------------------------------------

void VRML_APPEARANCE::Print (ofstream &vrml)
{
  vrml<<"Appearance {"<<endl;
  if(material!=NULL)
  {
    vrml<<" material ";
    material->Print(vrml);
  }
  if(texture!=NULL)
  {
    vrml<<"texture ";
    texture->Print(vrml);
  }
  if(textureTransform!=NULL)
  {
    vrml<<" textureTransform ";
    textureTransform->Print(vrml);
  }
  vrml<<"}"<<endl;
}
//---------------------------------------------------------------------------

void VRML_LOD::Print (ofstream &vrml)
{
  vrml<<"LOD {"<<endl;
  if(center.x!=0 || center.y!=0 || center.z!=0)
    vrml<<"center "<<center<<endl;     //  0 0 0    # (-,)
  if(  num_level>0 )
  {
    if(range[0]!=0  )
    {
      vrml<<"range ["<<endl;
      for(int i=0;i<num_level-1;i++)
      {
        if(range[i]!=0)
          vrml<<range[i]<<" ";
      }
      vrml<<"]"<<endl;
    }
    vrml<<"level ["<<endl;
    for(int i=0;i<num_level;i++)
    {
      level[i]->Print(vrml);
      vrml<<endl;
    }
    vrml<<"]"<<endl;
  }
  vrml<<"}"<<endl;
}
//---------------------------------------------------------------------------
VRML_INLINE::VRML_INLINE(String s)
{
  url[0]=s;
  num_url=1;
  bboxCenter=vrml_Vect3f(0,0,0);
  bboxSize=vrml_Vect3f(-1,-1,-1);
}
//---------------------------------------------------------------------------

void VRML_INLINE::Print (ofstream &vrml)
{
  vrml<<"Inline {"<<endl;
  if(num_url>0)
  {
    vrml<<"url ["<<endl;
    for(int i=0;i<num_url;i++)
    {
      vrml<<"\""<<url[i].c_str()<<"\" ";
    }
    vrml<<"]"<<endl;
  }
  if(bboxCenter.x!=0 || bboxCenter.y!=0 || bboxCenter.z!=0)
    vrml<<"bboxCenter "<<bboxCenter<<endl; //0 0 0     # (-,)
  if(bboxSize.x!=-1 || bboxSize.y!=-1 || bboxSize.z!=-1)
    vrml<<"bboxSize "<<bboxSize<<endl; // -1 -1 -1  # (0,) or -1,-1,-1
  vrml<<"}"<<endl;
}

//---------------------------------------------------------------------------

void VRML_TEXTURETRANSFORM::Print (ofstream &vrml)
{
  vrml<<"TextureTransform {"<<endl;
  if(center.x!=0 || center.y!=0)
    vrml<<"center "<<center<<endl;
  if(rotation!=0)
    vrml<<"rotation "<<rotation<<endl;
  if(scale.x!=1 ||scale.y!=1)
    vrml<<"scale "<<scale<<endl;
  if(translation.x!=0 ||translation.y!=0)
    vrml<<"translation "<<translation<<endl;
  vrml<<"}"<<endl;
}

//---------------------------------------------------------------------------

